/* 
 * * ******************************************************************
 *
 *   CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *   AUTHOR                         ->        dariusz.bi@modulesgarden.com
 *   CONTACT                        ->        contact@modulesgarden.com
 *
 *  This software is furnished under a license and may be used and copied
 *  only  in  accordance  with  the  terms  of such  license and with the
 *  inclusion of the above copyright notice.  This software  or any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and  ownership of the  software is  hereby
 *  transferred.
 *
 * * ******************************************************************
 */

document.observe('click', function (event) {
    var element = event.element();
    var token = element.getAttribute('data-token');
    var orderid = element.getAttribute('data-orderid');
    var domainID = element.getAttribute('data-domainid');
    var relid = element.getAttribute('data-relid');
    var certserialnumber = element.getAttribute('data-certserialnumber');

    if (element.hasClassName('btn') && Event.isLeftClick(event)) {
        $$('.btn').invoke('addClassName', 'disabled');
        var action = element.getAttribute('data-action');

        var status = '';
        switch (action) {
            case 'Cancel':
                status = 'CANCELLED';
                break;
            case 'Revoke':
                status = 'REVOKED. Refreshing list. Please wait.';
                break;
            case 'Reissue':
                status = 'REISSUED. Refreshing list. Please wait.';
                break;
        }

        if (action) {
            if (action != 'Info' && action != 'clearConfig') {
                //if(confirm('Are you sure you want to '+action+' cert for this domain?')){
                Event.stop(event);

                var domainName = element.up('tr').firstDescendant().innerHTML.stripTags();
                if (action != 'Cancel' && action != 'Revoke') {
                    var r = true;
                } else {
                    r = confirm("Are you sure you want to " + action.toLowerCase() + " this certificate?");
                }
                if (r == true) {
                    new Ajax.Request('/modules/CertumSSL/index.php/client/ajax', {
                        method: 'post',
                        parameters: {domainname: domainName, token: token, orderid: orderid, action: action, serialNumber: certserialnumber,relid:relid},
                        onSuccess: function (response) {
                            $$('.op-msg-box-error').invoke('remove');
                            $$('.op-msg-box-success').invoke('remove');
                            if (response.responseJSON.status == 'error' && response.responseJSON.msg != null) {

                                var errorContainer = '<div class="op-msg-box-error">' + response.responseJSON.msg + '</div>';
                                element.up('td').insert(errorContainer);
                                $$('.btn').invoke('removeClassName', 'disabled');

                            } else {
                                if (response.responseJSON.msg == null) {
                                    response.responseJSON.msg = "Certificate has been canceled.";
                                }
                                var successContainer = '<div class="op-msg-box-info">' + response.responseJSON.msg + '</div>';
                                element.up('td').insert(successContainer);
                                element.up('tr').childElements()[3].update(status);
                                $$('.btn').invoke('removeClassName', 'disabled');

                            }
                            if (action == 'Reissue' || action == 'Revoke') {
                                window.setTimeout(function () {
                                    location.reload(true)
                                }, 5000);
                            }
                        },
                        onFailure: function (response) {
                            window.location.reload();
                        }
                    });
                } else {
                    $$('.btn').invoke('removeClassName', 'disabled');
                }
                /*
                 } else {
                 $$('.btn').invoke('removeClassName','disabled');
                 }
                 */
            } else if (action == 'Info') {
                Event.stop(event);
                $$('.op_single_param').invoke('hide');
                $('organizationInfo').hide();
                $('requestorInfo').hide();
                $('orderdefault').hide();

                var domainName = element.up('tr').firstDescendant().innerHTML.stripTags();
                $$('.btn').invoke('removeClassName', 'disabled');
                new Ajax.Request('/modules/CertumSSL/index.php/client/ajax', {
                    method: 'post',
                    parameters: {domainID: domainID, token: token, orderid: orderid,relid:relid, action: action},
                    onSuccess: function (response) {

                        var params = response.responseJSON.params;
                        window.scrollTo(0, 0);

                        $('screenDisabler').show();
                        $('modalDialogBox').show();
                        $H(params).each(function (info) {
                            $(info.key).show();
                            $H(info.value).each(function (paramData) {
                                if ($(paramData.key) != undefined) {
                                    $(paramData.key).up().show();
                                    $(paramData.key).update(paramData.value);
                                }
                            });
                        });

                    },
                    onFailure: function (response) {
                        window.location.reload();
                    }
                });
            } else if (action == 'clearConfig') {
                $$('.btn').invoke('removeClassName', 'disabled');
                new Ajax.Request('/modules/CertumSSL/index.php/index/clearconf', {
                    method: 'get',
                    onSuccess: function (response) {
                        var currentURL = window.location.href;
                        if (currentURL.indexOf('index.php') == -1) {
                            window.location.href += 'index.php/index/index/clearconf/success';
                        } else {
                            window.location.href += '/clearconf/success';
                        }
                    }
                });
            }
        }
    }

    if (element.hasClassName('op_close_dialog') && Event.isLeftClick(event)) {
        $('screenDisabler').hide();
        $('modalDialogBox').hide();
    }

    if (Element.up(element).id == 'btn-test_connection' && Event.isLeftClick(event)) {

        var url = $$('[name="sys_config_wdsl"]')[0].value;
        var user = $$('[name="sys_config_user"]')[0].value;
        var pass = $$('[name="sys_config_password"]')[0].value;
        new Ajax.Request('/modules/CertumSSL/index.php/index/ajax', {
            method: 'post',
            parameters: {action: 'testConnection', user: user, url: url, pass: pass},
            onLoading: function (resonse) {
                $('button_test_connection-form-row').childElements()[1].update('<img style="padding-top: 8px;" src="/theme/images/indicator.gif">');
            },
            onSuccess: function (response) {
                $('button_test_connection-form-row').childElements()[1].update("<p style='padding-top: 8px;'>" + response.responseJSON.msg + "</p>");
            }
        });
    }

    if (Element.up(element).hasClassName('btn') && Event.isLeftClick(event)) {

        var buttonId = Element.up(element).id;
        if (buttonId.indexOf('btn-add_new_account_') != -1) {
            var lastAccountId = buttonId.replace('btn-add_new_account_', '');
            var newID = parseInt(lastAccountId) + 1;
            var form = '<div id="sys_config_wdsl_1-form-row" class="form-row">\n\
                        <div class="field-name">\n\
                            <label for="sys_api_wsdl_url_' + newID + '">API URL&nbsp;<span class="required">*</span></label>\n\
                        </div>\n\
                        <div class="field-value">\n\
                            <input type="text" name="sys_api_wsdl_url_' + newID + '" id="sys_api_wsdl_url_' + newID + '" value="" class="input-text">\n\
                            <span class="field-errors" style="display:none;"></span>\n\
                        </div>\n\
                    </div>\n\
                    <div id="sys_api_login_' + newID + '-form-row" class="form-row">\n\
                        <div class="field-name"><label for="sys_api_login_' + newID + '">User&nbsp;<span class="required">*</span></label></div>\n\
                        <div class="field-value">\n\
                            <input type="text" name="sys_api_login_' + newID + '" id="sys_api_login_' + newID + '" value="" class="input-text">\n\
                            <span class="field-errors" style="display:none;"></span>\n\
                        </div>\n\
                    </div>\n\
                    <div id="sys_api_password_' + newID + '-form-row" class="form-row">\n\
                        <div class="field-name"><label for=""sys_api_password_' + newID + '">Password&nbsp;<span class="required">*</span></label></div>\n\
                        <div class="field-value">\n\
                            <input type="text" name="sys_api_password_' + newID + '" id=""sys_api_password_' + newID + '" value="" class="input-text">\n\
                        </div>\n\
                    </div>\n\
                    <div id="sys_api_wsdl_products_' + newID + '-form-row" class="form-row">\n\
                    <div class="field-name"><label for="sys_api_wsdl_products_' + newID + '">Attached Products&nbsp;<span class="required">*</span></label></div>\n\
                    <div class="field-value">\n\
                        <div class="text-value">\n\
                            <label for="sys_api_wsdl_products_' + newID + '-spacessl_domain_validation">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-spacessl_domain_validation" value="spacessl_domain_validation"> SpaceSSL Domain Validation</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-spacessl_wildcard">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-spacessl_wildcard" value="spacessl_wildcard"> SpaceSSL Wildcard</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-spacessl_multidomain">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-spacessl_multidomain" value="spacessl_multidomain"> SpaceSSL MultiDomain</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-commercial_ssl">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-commercial_ssl" value="commercial_ssl"> Commercial SSL</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-commercial_wildcard">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-commercial_wildcard" value="commercial_wildcard"> Commercial Wildcard</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-commercial_multidomain_ssl">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-commercial_multidomain_ssl" value="commercial_multidomain_ssl"> Commercial MultiDomain SSL</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-trusted_ssl">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-trusted_ssl" value="trusted_ssl"> Trusted SSL</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-trusted_wildcard_ssl">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-trusted_wildcard_ssl" value="trusted_wildcard_ssl"> Trusted Wildcard SSL</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-trusted_multidomain_ssl">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-trusted_multidomain_ssl" value="trusted_multidomain_ssl"> Trusted MultiDomain SSL</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-test_ssl">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-test_ssl" value="test_ssl"> Test SSL</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-premium_ev_ssl">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-premium_ev_ssl" value="premium_ev_ssl"> Premium EV SSL</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-premium_ev_multidomain_ssl">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-premium_ev_multidomain_ssl" value="premium_ev_multidomain_ssl"> Premium EV MultiDomain SSL</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-open_source_developer">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-open_source_developer" value="open_source_developer"> Open Source Developer</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-standard_code_signing">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-standard_code_signing" value="standard_code_signing"> Standard Code Signing</label><br>\n\
                            <label for="sys_api_wsdl_products_' + newID + '-microsoft_code_signing">\n\
                            <input type="checkbox" name="sys_api_wsdl_products_' + newID + '[]" id="sys_api_wsdl_products_' + newID + '-microsoft_code_signing" value="microsoft_code_signing"> Microsoft Code Signing</label></div>\n\
                            <span class="field-errors" style="display:none;"></span>\n\
                        </div>\n\
                    </div>\n\
                    <div id="sys_api_wsdl_lang_' + newID + '-form-row" class="form-row">\n\
                        <div class="field-name"><label for="sys_api_wsdl_lang_' + newID + '">Language&nbsp;<span class="required">*</span></label></div>\n\
                        <div class="field-value">\n\
                            <select name="sys_api_wsdl_lang_' + newID + '" id="sys_api_wsdl_lang_' + newID + '">\n\
                                <option value="PL" label="PL">PL</option>\n\
                                <option value="EN" label="EN">EN</option>\n\
                            </select>\n\
                            <span class="field-errors" style="display:none;"></span>\n\
                        </div>\n\
                    </div>\n\
                    <span id="btn-test_connection_' + newID + '" class="btn"><button type="button" value="" name="button_test_mode">Test Connection</button></span>\n\
                    <span id="btn-add_new_account_' + newID + '" class="btn"><button type="button" value="" name="button_add_apiuser">Add New Account</button></span>\n\
                    <div id="button_test_connection_' + newID + '-form-row" class="form-row">\n\
                        <div class="field-name">\n\
                        <label for="button_test_connection_' + newID + '">&nbsp;</label></div>\n\
                        <div class="field-value">\n\
                                <div class="text-value">\n\
                                    <span id="button_test_connection_' + newID + '"></span>\n\
                                </div>\n\
                        </div>\n\
                    </div>';
                        
            $('button_test_connection_'+lastAccountId+'-form-row').insert({after: form});
            $(Element.up(element)).hide();
        }

        if (buttonId.indexOf('btn-test_connection_') != -1) {
            var connId = buttonId.replace('btn-test_connection_', '');
            var newID = parseInt(connId) + 1;
            console.log(connId);
            console.log(newID);
            var url = $$('[name="sys_api_wsdl_url_'+connId+'"]')[0].value;
            var user = $$('[name="sys_api_login_'+connId+'"]')[0].value;
            var pass = $$('[name="sys_api_password_'+connId+'"]')[0].value;
            new Ajax.Request('/modules/CertumSSL/index.php/index/ajax', {
                method: 'post',
                parameters: {action: 'testConnection', user: user, url: url, pass: pass},
                onLoading: function (resonse) {
                    $('button_test_connection-form-row').childElements()[1].update('<img style="padding-top: 8px;" src="/theme/images/indicator.gif">');
                },
                onSuccess: function (response) {
                    console.log(response);
                    if(typeof response.responseJSON !== 'undefined'){
                        $('button_test_connection_'+connId+'-form-row').childElements()[1].update("<p style='padding-top: 8px;'>" + response.responseJSON.msg + "</p>");
                    }else{
                        $('button_test_connection_'+connId+'-form-row').childElements()[1].update("<p style='padding-top: 8px;'>Connection Failed</p>");
                    }
                    
                }
            });
        }



    }



    if (Element.up(element).id == 'btn-config_export' && Event.isLeftClick(event)) {
        var form = new Element('form', {method: 'post', action: '/modules/CertumSSL/index.php/index/saveconffile'});
        var params = $('pm-form-simple').serialize(true);
        for (var key in params)
        {
            form.insert(new Element('input', {name: key, value: params[key], type: 'hidden'}));
        }
        $(document.body).insert(form);
        form.submit();
    }

    if (Element.up(element).id == 'btn-config_import' && Event.isLeftClick(event)) {
        Jsw.messageBox.show({
            type: Jsw.messageBox.TYPE_YESNO,
            text: 'Are you sure to update configuration from file?',
            subtype: 'confirm',
            onYesClick: function () {
                window.location.href = "/modules/CertumSSL/index.php/index/updateconffile";
            },
            buttonTitles: {
                'yes': 'Yes',
                'no': 'No'
            }
        });
    }

    if (element.id == 'accept-statement' && Event.isLeftClick(event)) {
        var id = element.getAttribute('data-id');
        var token = element.getAttribute('data-token');
        window.location.href = "/modules/CertumSSL/index.php/client/cert/token/" + token + "/id/" + id;
    }

    if (element.id == 'decline-statement' && Event.isLeftClick(event)) {
        window.location.href = "/modules/CertumSSL/index.php/client";
    }

    if (element.id == 'apilogs_clean_logs' && Event.isLeftClick(event)) {
        if (confirm('Are you sure you want to delete all Logs ? ')) {
            Event.stop(event);

            new Ajax.Request('/modules/CertumSSL/index.php/client/ajax', {
                method: 'post',
                parameters: {action: 'cleanlogs'},
                onSuccess: function (response) {
                    if (response.responseJSON.status == 'success') {
                        window.location.href = window.location.href + '/cleanlogs/success';
                    }
                }
            });
        }
    }

    if (element.id == 'apilogs_change_status' && Event.isLeftClick(event)) {
        Event.stop(event);

        new Ajax.Request('/modules/CertumSSL/index.php/client/ajax', {
            method: 'post',
            parameters: {action: 'changelogstatus'},
            onSuccess: function (response) {
                if (response.responseJSON.status == 'success') {
                    window.location.reload();
                }
            }
        });
    }
});

document.observe("dom:loaded", function () {
    if ($('button_test_connection-form-row') != null) {
        //$('button_test_connection-form-row').childElements()[0].insert($("btn-test_connection"));
        //$('test_mode_container-form-row').childElements()[1].insert($$('.indent-box')[0]);
        //$('test_mode_container-form-row').next().remove();
    }
});
