<?php
/*
 * * ******************************************************************
 *
 *   CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *   AUTHOR                         ->     dariusz.bi@modulesgarden.com
 *   CONTACT                        ->       contact@modulesgarden.com
 *
 *  This software is furnished under a license and may be used and copied
 *  only  in  accordance  with  the  terms  of such  license and with the
 *  inclusion of the above copyright notice.  This software  or any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and  ownership of the  software is  hereby
 *  transferred.
 *
 * * ******************************************************************
 */

define("DS", DIRECTORY_SEPARATOR);
define("CERTCENTERSSL_INCLUDES", '/opt/psa/admin/plib/modules/CertumSSL/core/');
require_once CERTCENTERSSL_INCLUDES.'CertumSSLLoader.php';

class IndexController extends pm_Controller_Action
{
    protected $db;
    private $main;

    public function init()
    {
        parent::init();
        $session    = new \pm_Session;
        $this->main = new CertumSSLMainController('Plesk', '/opt/psa/admin/plib/modules/CertumSSL');
        if (!$session->getClient()->isAdmin()) {
            $this->_forward('nopermission');
        }
        $this->db              = pm_Bootstrap::getDbAdapter();
        $this->view->pageTitle = pm_Locale::lmsg('module_name');

        $this->view->tabs = array(
            array(
                'title' => 'Configuration',
                'action' => 'index',
            ),
            array(
                'title' => 'Logs',
                'action' => 'apilogs',
            )
        );
    }

    public function nopermissionAction()
    {
        
    }

    public function indexAction()
    {

        $form                   = $this->_configForm();
        $this->view->apimessage = 'Please fill the form below with API details.';

        $this->view->form         = $form;
        $this->view->pageTitle    = pm_Locale::lmsg('module_name');
        $this->view->tabPageTitle = pm_Locale::lmsg('config_page_title');

        if ($this->getRequest()->isPost() && $form->isValid($this->getRequest()->getPost())) {
            $this->_saveConfigParams($form);
        }
    }

    public function apilogsAction()
    {
        if ($this->_getParam('cleanlogs') && $this->_getParam('cleanlogs') == 'success') {
            $this->view->info = 'API Logs has been successfully cleared.';
        }

        $list                    = $this->getLogsList();
        $this->view->list        = $list;
        $this->view->logs_status = CertumSSLDriver::config()->apilogs_turnon_value;

        if (CertumSSLDriver::config()->apilogs_turnon_value == 'on') {
            $this->view->logs_status_value = 'off';
        } else {
            $this->view->logs_status_value = 'on';
        }
    }

    public function saveconffileAction()
    {

        $this->_helper->viewRenderer->setNoRender(true);

        $path = dirname(dirname(__FILE__)).DS.'etc'.DS.'PredefinedConfiguration.ini';

        $input = $this->getRequest()->getPost();

        $res = array();
        foreach ($input as $inpuName => $inpuVal) {

            if (strpos($inpuName, "sys_api_") !== false) {
                $last  = strrpos($inpuName, "_");
                $relid = substr($inpuName, (int) $last + 1 - strlen($inpuName));

                $name = substr($inpuName, 4, $last - 4);

                if (strpos($inpuName, "api_wsdl_products") !== false) {
                    $inpuVal = implode(",", $inpuVal);
                }

                $res[] = $name."[".$relid."] = ".$inpuVal;
            } else {
                if (strpos($inpuName, 'sys_') !== false && strpos($inpuName, 'sys_testConnectionId') === false) {
                    $inpuName = str_replace("sys_", "", $inpuName);
                    if (is_array($inpuVal)) {
                        $res[] = "[$inpuName]";
                        foreach ($inpuVal as $skey => $sval)
                            $res[] = "$skey = ".(is_numeric($sval) ? $sval : '"'.$sval.'"');
                    } else {
                        $res[] = "$inpuName = ".(is_numeric($inpuVal) ? $inpuVal : '"'.$inpuVal.'"');
                    }
                }
            }
        }

        $dataToSave = implode("\r\n", $res);

        $configFile = fopen($path, 'w');

        fwrite($configFile, $dataToSave);
        fclose($configFile);

        header('Content-Description: File Transfer');
        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename="'.basename($path).'"');
        header('Expires: 0');
        header('Cache-Control: must-revalidate');
        header('Pragma: public');
        header('Content-Length: '.filesize($path));
        readfile($path);
        exit;
    }

    public function updateconffileAction()
    {

        $this->_helper->viewRenderer->setNoRender(true);
        $configuration = new CertumSSLConfiguration();
        $path          = dirname(dirname(__FILE__)).DS.'etc'.DS.'PredefinedConfiguration.ini';

        $predefinedConfig = parse_ini_file($path);
        foreach ($predefinedConfig as $configName => $configValue) {

            if (is_array($configValue)) {
                foreach ($configValue as $relid => $value) {
                    if (strpos($configName, "api_wsdl_products") !== false) {
                        $productsArray = explode(",", $value);
                        $value         = json_encode($productsArray);
                    }

                    $configuration->setAPIAccountsParams($configName, $value, $relid);
                }
            } else {
                $configuration->setAPIAccountsParams($configName, $configValue, 0);
            }
        }

        $this->_status->addMessage('info', 'Data was successfully updated.');
        $this->_forward('index');
    }

    public function ajaxAction()
    {
        if ($this->_request->isPost()) {
            $postData = $this->_request->getPost();

            $action = $postData['action'];

            switch ($action) {
                case 'testConnection':

                    CertumSSLDriver::remoteAPI()->setConnectionParams(array("api_login" => $postData['user'], "api_password" => $postData['pass'], "api_url" => $postData['url']));
                    $op = CertumSSLDriver::remoteAPI()->operationGetStatement();
                    $op->setLanguage("pl");

                    $response = $op->call();
                    if (!$response || (!is_object($response) && isset($response['errors']))) {
                        $this->_helper->json(array('status' => 'error', 'msg' => pm_Locale::lmsg('error_connection')));
                        die();
                    }

                    $this->_helper->json(array('status' => 'success', 'msg' => pm_Locale::lmsg('good_connection')));
                    die;
                    break;
            }
            $this->_helper->json(array('status' => 'error', 'msg' => pm_Locale::lmsg('client_error_ajax')));
        }
    }

    public function cronlogsAction()
    {
        $list             = $this->getCronList();
        $this->view->list = $list;
    }

    public function listDataAction()
    {
        $list = $this->getLogsList();

        // Json data from pm_View_List_Simple
        $this->_helper->json($list->fetchData());
    }

    public function listCronsAction()
    {
        $list = $this->getCronList();
        // Json data from pm_View_List_Simple
        $this->_helper->json($list->fetchData());
    }

    private function getLogsList()
    {
        $data     = array();
        $list     = new pm_View_List_Simple($this->view, $this->_request);

        $logsList = MGAPILogs::listAPILogs(array('id' => 'DESC'), CertumSSLDriver::config()->logs_limit);

        if ($logsList[0]) {
            foreach ($logsList as $error) {

                //$test = json_decode($error['request'], true);
                $data[] = array(
                    'column-1' => $error['id'],
                    'column-2' => $error['date'],
                    'column-3' => '<textarea class="test" rows="12" cols="60">'.htmlentities($error['request']).'</textarea>',
                    'column-4' => '<textarea rows="12" cols="60">'.$error['response'].'</textarea>'
                );
            }

            $list->setData($data);

            $list->setColumns(array(
                'column-1' => array(
                    'title' => pm_Locale::lmsg('apilogs_id'),
                    'noEscape' => true,
                ),
                'column-2' => array(
                    'title' => pm_Locale::lmsg('apilogs_datetime'),
                    'noEscape' => true,
                ),
                'column-3' => array(
                    'title' => pm_Locale::lmsg('apilogs_request'),
                    'noEscape' => true,
                ),
                'column-4' => array(
                    'title' => pm_Locale::lmsg('apilogs_response'),
                    'noEscape' => true,
                )
            ));
        }

        $list->setDataUrl(array('action' => 'list-data'));
        return $list;
    }

    private function getCronList()
    {
        $data = array();
        $task = new MGCronLogs(array('_tableName' => 'certumssl_cron_tasks'));
        $list = new pm_View_List_Simple($this->view, $this->_request);

        if ($task->getAllTasks()) {

            foreach ($task->getAllTasks() as $task) {

                if ($task['finished'] == 1) {
                    $certStatus = 'Installed';
                } else {
                    $certStatus = 'Not installed';
                }

                $CertOrders      = new MGCertOrders(array('_tableName' => 'cert_center_orders', 'orderVoucher' => $task['orderVoucher']));
                $certOrderParams = $CertOrders->getCertumOrderByVoucherCode();
                $userDomain      = CertumSSLDriver::localAPI()->getUserDomainById($task['domain_id']);

                $data[] = array(
                    'column-1' => $task['id'],
                    'column-2' => CertumSSLDriver::localAPI()->getUserNameById($task['user_id']),
                    'column-3' => CertumSSLDriver::localAPI()->getUserEmailById($task['user_id']),
                    'column-4' => $userDomain['name'],
                    'column-5' => $task['orderVoucher'],
                    'column-6' => $certOrderParams['cc_order_id'],
                    'column-7' => $task['create_date'],
                    'column-8' => $task['last_try_date'],
                    'column-9' => $task['activate_date'],
                    'column-10' => $certStatus,
                );
            }

            $list->setData($data);

            $list->setColumns(array(
                'column-1' => array(
                    'title' => pm_Locale::lmsg('cronlogs_id'),
                    'noEscape' => true,
                ),
                'column-2' => array(
                    'title' => pm_Locale::lmsg('cronlogs_username'),
                    'noEscape' => true,
                ),
                'column-3' => array(
                    'title' => pm_Locale::lmsg('cronlogs_useremail'),
                    'noEscape' => true,
                ),
                'column-4' => array(
                    'title' => pm_Locale::lmsg('cronlogs_domain'),
                    'noEscape' => true,
                ),
                'column-5' => array(
                    'title' => pm_Locale::lmsg('cronlogs_voucher'),
                    'noEscape' => true,
                ),
                'column-6' => array(
                    'title' => pm_Locale::lmsg('cronlogs_certcenterorderid'),
                    'noEscape' => true,
                ),
                'column-7' => array(
                    'title' => pm_Locale::lmsg('cronlogs_createdate'),
                    'noEscape' => true,
                ),
                'column-8' => array(
                    'title' => pm_Locale::lmsg('cronlogs_lastrundate'),
                    'noEscape' => true,
                ),
                'column-9' => array(
                    'title' => pm_Locale::lmsg('cronlogs_activedate'),
                    'noEscape' => true,
                ),
                'column-10' => array(
                    'title' => pm_Locale::lmsg('cronlogs_certstatus'),
                    'noEscape' => true,
                )
            ));
        }

        $list->setDataUrl(array('action' => 'list-crons'));
        return $list;
    }

    public function apiLogsListAction()
    {
        $this->_helper->json($this->getAllApiLogs()->fetchAll());
    }

    public function _saveConfigParams($form)
    {
        $validator = new Zend_Validate_EmailAddress();
        if ($validator->isValid($form->getValue('sys_config_email'))) {
            // email appears to be valid
        } else {
            // email is invalid; print the reasons
            foreach ($validator->getMessages() as $message) {
                $this->_status->addMessage('error', 'Wrong Adres Email.');
                $this->_helper->json(array('redirect' => pm_Context::getBaseUrl()));
            }
        }

        $configuration = new CertumSSLConfiguration();

        $configuration->apiAccountsParamsClean();
        foreach ($_POST as $inpuName => $inpuVal) {

            if (strpos($inpuName, "sys_api_") !== false) {
                $last  = strrpos($inpuName, "_");
                $relid = substr($inpuName, (int) $last + 1 - strlen($inpuName));
                $name  = substr($inpuName, 4, $last - 4);

                if (strpos($inpuName, "api_wsdl_products") !== false) {
                    $inpuVal = json_encode($inpuVal);
                }
                $configuration->setAPIAccountsParams($name, $inpuVal, $relid);
            }
        }

        CertumSSLDriver::config()->billing_url = $form->getValue('sys_billing_url');

        CertumSSLDriver::config()->email  = $form->getValue('sys_config_email');
        CertumSSLDriver::config()->sender = $form->getValue('sys_config_sender');

        CertumSSLDriver::config()->success_email_subject = $form->getValue('sys_config_success_email_subject');
        CertumSSLDriver::config()->success_email_message = $form->getValue('sys_config_success_email_message');

        CertumSSLDriver::config()->logs_limit = $form->getValue('sys_config_logs_limit');


        $number_validator = new Zend_Validate_Digits();
        if ($number_validator->isValid($form->getValue('sys_config_logs_limit'))) {
            // email appears to be valid
        } else {
            // email is invalid; print the reasons
            foreach ($number_validator->getMessages() as $message) {
                $this->_status->addMessage('error', 'Wrong Activity Limit Number.');
                $this->_helper->json(array('redirect' => pm_Context::getBaseUrl()));
            }
        }


        $this->_status->addMessage('info', 'Data was successfully saved.');
        $this->_helper->json(array('redirect' => pm_Context::getBaseUrl()));
    }

    public function _configForm()
    {

        $configuration    = new CertumSSLConfiguration();
        $SSLProducts      = new SSLProducts();
        $predefinedConfig = parse_ini_file('/opt/psa/admin/plib/modules/CertumSSL'.DS.'etc'.DS.'PredefinedConfiguration.ini');

        $form             = new pm_Form_Simple();
        $form->addElement('button', 'button_export', array('label' => pm_Locale::lmsg('config_export'), 'attribs' => array('id' => "config_export")))
            ->addElement('button', 'button_import', array('label' => pm_Locale::lmsg('config_import'), 'attribs' => array('id' => "config_import")))
            ->addElement('SimpleText', 'api_configuration', array('label' => pm_Locale::lmsg('config_api_configuration')));

        if (count($configuration->getAPIAccountsParams()) <= 0) {
            $relid = 1;

            $form->addElement('text', 'sys_api_wsdl_url_'.$relid,
                    array('label' => pm_Locale::lmsg('config_wdsl'), 'value' => isset($_POST['sys_api_wsdl_url_1']) ? $_POST['sys_api_wsdl_url_1'] : $predefinedConfig['api_wsdl_url'][$relid], 'required' => true))
                ->addElement('text', 'sys_api_login_'.$relid,
                    array('label' => pm_Locale::lmsg('config_user'), 'value' => isset($_POST['sys_api_login_1']) ? $_POST['sys_api_login_1'] : $predefinedConfig['api_login'][$relid], 'required' => true))
                ->addElement('text', 'sys_api_password_'.$relid,
                    array('label' => pm_Locale::lmsg('config_password'), 'value' => isset($_POST['sys_api_password_1']) ? $_POST['sys_api_password_1'] : $predefinedConfig['api_password'][$relid], 'required' => true))
                ->addElement('MultiCheckbox', 'sys_api_wsdl_products_'.$relid,
                    array('label' => pm_Locale::lmsg('config_products'), 'value' => isset($_POST['sys_api_wsdl_products_1']) ? $_POST['sys_api_wsdl_products_1'] : $predefinedConfig['api_wsdl_products'][$relid],
                    'multiOptions' => $SSLProducts->names, 'required' => false))
                ->addElement('select', 'sys_api_wsdl_lang_'.$relid,
                    array('label' => pm_Locale::lmsg('config_language'), 'value' => isset($_POST['sys_api_wsdl_lang_1']) ? $_POST['sys_api_wsdl_lang_1'] : $predefinedConfig['api_wsdl_lang'][$relid], 'multiOptions' => array(
                        "PL" => "PL", "EN" => "EN"), 'required' => true))
                ->addElement('button', 'button_test_mode', array('label' => pm_Locale::lmsg('config_testconection'), 'attribs' => array('id' => "test_connection_".$relid)))
                ->addElement('button', 'button_add_apiuser', array('label' => pm_Locale::lmsg('config_addapiuser'), 'attribs' => array('id' => "add_new_account_".$relid)));
            $form->addElement('SimpleText', 'button_test_connection_'.$relid, array('label' => ""));
        } else {
            $i = 0;
            foreach ($configuration->getAPIAccountsParams() as $relid => $accountParams) {
                $i++;
                $form->addElement('text', 'sys_api_wsdl_url_'.$relid,
                        array('label' => pm_Locale::lmsg('config_wdsl'), 'value' => isset($accountParams['api_wsdl_url']) ? $accountParams['api_wsdl_url'] : $predefinedConfig['api_wsdl_url'][$relid], 'required' => true))
                    ->addElement('text', 'sys_api_login_'.$relid,
                        array('label' => pm_Locale::lmsg('config_user'), 'value' => isset($accountParams['api_login']) ? $accountParams['api_login'] : $predefinedConfig['api_login'][$relid], 'required' => true))
                    ->addElement('text', 'sys_api_password_'.$relid,
                        array('label' => pm_Locale::lmsg('config_password'), 'value' => isset($accountParams['api_login']) ? $accountParams['api_password'] : $predefinedConfig['api_password'][$relid],
                        'required' => true))
                    ->addElement('MultiCheckbox', 'sys_api_wsdl_products_'.$relid,
                        array( 'label' => pm_Locale::lmsg('config_products'), 'value' => isset($accountParams['api_wsdl_products']) ? json_decode($accountParams['api_wsdl_products'],
                                true) : $predefinedConfig['api_wsdl_products'][$relid], 'multiOptions' => $SSLProducts->names, 'required' => false))
                    ->addElement('select', 'sys_api_wsdl_lang_'.$relid,
                        array('label' => pm_Locale::lmsg('config_language'), 'value' => isset($accountParams['api_wsdl_lang']) ? $accountParams['api_wsdl_lang'] : $predefinedConfig['api_wsdl_lang'][$relid],
                        'multiOptions' => array("PL" => "PL", "EN" => "EN"), 'required' => true))
                    ->addElement('button', 'button_test_mode_'.$relid, array('label' => pm_Locale::lmsg('config_testconection'), 'attribs' => array('id' => "test_connection_".$relid)));

                //$form->addElement('button','button_test_mode',array('label'=>pm_Locale::lmsg('config_testconection'), 'attribs'=> array('id' => "test_connection_".$relid)));
                if (count($configuration->getAPIAccountsParams()) == $i) {
                    $form->addElement('button', 'button_add_apiuser', array('label' => pm_Locale::lmsg('config_addapiuser'), 'attribs' => array('id' => "add_new_account_".$i)));
                }
                $form->addElement('SimpleText', 'button_test_connection_'.$relid, array('attribs' => array("class" => "form-row testConn"), 'attributes' => array("class" => "form-row testConn")));
            }
        }
        $form->addElement('SimpleText', 'config_billing_head', array('label' => pm_Locale::lmsg('config_billing_head')))
            ->addElement('text', 'sys_billing_url',
                array('label' => pm_Locale::lmsg('config_billing_url'), 'value' => isset(CertumSSLDriver::config()->billing_url) ? CertumSSLDriver::config()->billing_url : (isset($_POST['sys_billing_url'])
                            ? $_POST['sys_billing_url'] : $predefinedConfig['billing_url']), 'size' => 30))
            ->addElement('SimpleText', 'admin_notifications', array('label' => pm_Locale::lmsg('config_admin_notifications')))
            ->addElement('text', 'sys_config_email',
                array('label' => pm_Locale::lmsg('config_email'), 'value' => isset(CertumSSLDriver::config()->email) ? CertumSSLDriver::config()->email : (isset($_POST['sys_email']) ? $_POST['sys_email']
                            : $predefinedConfig['email']), 'size' => 30))
            ->addElement('text', 'sys_config_sender',
                array('label' => pm_Locale::lmsg('config_sender'), 'value' => isset(CertumSSLDriver::config()->sender) ? CertumSSLDriver::config()->sender : (isset($_POST['sys_sender']) ? $_POST['sys_sender']
                            : $predefinedConfig['sender']), 'size' => 30))
            ->addElement('SimpleText', 'user_notifications', array('label' => pm_Locale::lmsg('config_user_notifications')))
            ->addElement('text', 'sys_config_success_email_subject',
                array('label' => pm_Locale::lmsg('config_success_email_subject'), 'value' => isset(CertumSSLDriver::config()->success_email_subject) ? CertumSSLDriver::config()->success_email_subject : (isset($_POST['sys_success_email_subject'])
                            ? $_POST['sys_success_email_subject'] : $predefinedConfig['success_email_subject']), 'size' => 30))
            ->addElement('textarea', 'sys_config_success_email_message',
                array('label' => pm_Locale::lmsg('config_success_email_message'), 'value' => isset(CertumSSLDriver::config()->success_email_message) ? CertumSSLDriver::config()->success_email_message : (isset($_POST['sys_success_email_message'])
                            ? $_POST['sys_success_email_message'] : $predefinedConfig['success_email_message']), 'rows' => 6, 'cols' => 35))
            ->addElement('SimpleText', 'logs_limit_activity_desc', array('label' => pm_Locale::lmsg('config_logs_limit_activity_desc')))
            ->addElement('text', 'sys_config_logs_limit',
                array('label' => pm_Locale::lmsg('logs_limit'), 'Description' => 'The number of activity log entries you wish to keep', 'value' => isset(CertumSSLDriver::config()->logs_limit) ? CertumSSLDriver::config()->logs_limit
                        : (isset($_POST['sys_logs_limit']) ? $_POST['sys_logs_limit'] : $predefinedConfig['logs_limit']), 'size' => 5))
            ->addControlButtons(array('cancelLink' => pm_Context::getModulesListUrl()
        ));
        return $form;
    }
}