<?php

/* 
 * * ******************************************************************
 *
 *   CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *   AUTHOR                         ->     dariusz.bi@modulesgarden.com
 *   CONTACT                        ->       contact@modulesgarden.com
 *
 *  This software is furnished under a license and may be used and copied
 *  only  in  accordance  with  the  terms  of such  license and with the
 *  inclusion of the above copyright notice.  This software  or any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and  ownership of the  software is  hereby
 *  transferred.
 *
 * * ******************************************************************
 */

function CertumSSLLoader($class)
{
    $searchDirs = array(
        'Classes','Classes'.DS.'Form',
        'Classes'.DS.'CertumSSLAPI',
        'Classes'.DS.'CertumSSLAPI'.DS.'exceptions',
        'Classes'.DS.'CertumSSLAPI'.DS.'messages',
        'Classes'.DS.'CertumSSLAPI'.DS.'operations',
        'Classes'.DS.'CertumSSLAPI'.DS.'types',
        'Models',
        'Drivers',
        'Classes'.DS.'Exceptions'
    );

    if(preg_match("/^([A-Z]{1,3}[a-z]{0,10})([A-Z][a-zA-Z]+)Driver$/D", $class,$results)){
        if($results[1].$results[2] == 'CertumSSL'){
            $driverFile = __DIR__.DS.'Drivers'.DS.$class.'.php';

            if(!file_exists($driverFile)){
                die("Unable to find File for Driver: ".$class);
            }

            require_once $driverFile;
        }else{
            $driverFile = __DIR__.DS.'Drivers'.DS.$results[1].DS.$class.'.php';
            if(!file_exists($driverFile)){
                die("Unable to find File for Driver: ".$class);
            }

            require_once $driverFile;
        }
    }elseif(strpos($class,'PartnerAPI') !== false){
        $classFileName = str_replace('PartnerAPI', '', $class);
        $found = false;
        foreach($searchDirs  as $dir){
            $classFile = __DIR__.DS.$dir.DS.lcfirst($classFileName).'.php'; 
            if(file_exists($classFile)){
                require_once $classFile;
                $found = true;
                break;
            }
        }
    }else{
        $found = false;
        foreach($searchDirs  as $dir){
            $classFile = __DIR__.DS.$dir.DS.$class.'.php';
            if(file_exists($classFile)){
                require_once $classFile;
                $found = true;
                break;
            }
        }

        if(!$found){
            die("Unable to find File for class: ".$class);
        }
    }
}

spl_autoload_register('CertumSSLLoader');

require_once __DIR__.DS.'CertumSSLMainController.php';