<?php

class SSLProducts
{
    public $fields = array(
        //'CN' => array('name' => 'common_name', 'label' => 'Common Name'),
        'O' => array('name' => 'organisation', 'label' => 'Organization'),
        'OU' => array('name' => 'organisation_unit', 'label' => 'Organizational Unit'),
        'L' => array('name' => 'locality', 'label' => 'Locality'),
        'SP' => array('name' => 'state_province', 'label' => 'State or Province Name'),
        'C' => array('name' => 'country', 'label' => 'Country'),
        'E' => array('name' => 'email', 'label' => 'Email'),
        'SN' => array('name' => 'serial_number', 'label' => 'Serial Number'),
        'BC' => array('name' => 'business_category', 'label' => 'Business Category'),
        'ST' => array('name' => 'street_address', 'label' => 'Street Address'),
        'P' => array('name' => 'postal_code', 'label' => 'Postal Code'),
        'JoILN' => array('name' => 'JoILN', 'label' => 'Jurisdiction of Incorporation Locality Name'),
        'JoISoPN' => array('name' => 'JoISoPN', 'label' => 'Jurisdiction of Incorporation State or Province Name'),
        'JoISoCN' => array('name' => 'JoISoCN', 'label' => 'Jurisdiction of Incorporation Country Name')
    );
    public $names = array(
        "spacessl_domain_validation" => "SpaceSSL Domain Validation",
        "spacessl_wildcard" => "SpaceSSL Wildcard",
        "spacessl_multidomain" => "SpaceSSL MultiDomain",
        "commercial_ssl" => "Commercial SSL",
        "commercial_wildcard" => "Commercial Wildcard",
        "commercial_multidomain_ssl" => "Commercial MultiDomain SSL",
        "trusted_ssl" => "Trusted SSL",
        "trusted_wildcard_ssl" => "Trusted Wildcard SSL",
        "trusted_multidomain_ssl" => "Trusted MultiDomain SSL",
        "test_ssl" => "Test SSL",
        "premium_ev_ssl" => "Premium EV SSL",
        "premium_ev_multidomain_ssl" => "Premium EV MultiDomain SSL",
        "open_source_developer" => "Open Source Developer",
        "standard_code_signing" => "Standard Code Signing",
        "microsoft_code_signing" => "Microsoft Code Signing",
        "professional_id" => "Professional ID",
        "enterprise_id" => "Enterprise ID",
        "basic_id" => "Basic ID"
    );

    public $productsFields = array(
        "spacessl_domain_validation" => array(
            //'CN' => 'required',
            'C' => 'required',
            'E' => 'optional'
        ),
        "spacessl_wildcard" => array(
            //'CN' => 'required',
            'C' => 'required',
            'E' => 'optional'
        ),
        "spacessl_multidomain" => array(
            //'CN' => 'required',
            'C' => 'required',
            'E' => 'optional'
        ),
        "commercial_ssl" => array(
            //'CN' => 'required',
            'C' => 'required',
            'E' => 'optional'
        ),
        "commercial_wildcard" => array(
            //'CN' => 'required',
            'C' => 'required',
            'E' => 'optional'
        ),
        "commercial_multidomain_ssl" => array(
            //'CN' => 'required',
            'C' => 'required',
            'E' => 'optional'
        ),
        "trusted_ssl" => array(
            //'CN' => 'required',
            'O' => 'optional',
            'OU' => 'optional',
            'L' => 'optional',
            'SP' => 'optional',
            'C' => 'required',
            'E' => 'optional'
        ),
        "trusted_wildcard_ssl" => array(
            //'CN' => 'required',
            'OU' => 'optional',
            'L' => 'optional',
            'SP' => 'optional',
            'C' => 'required',
            'E' => 'optional'
        ),
        "trusted_multidomain_ssl" => array(
            //'CN' => 'required',
            'OU' => 'optional',
            'L' => 'optional',
            'SP' => 'optional',
            'C' => 'required',
            'E' => 'optional'
        ),
        "test_ssl" => array(
            //'CN' => 'required',
            'C' => 'required',
            'E' => 'optional'
        ),
        "premium_ev_ssl" => array(
            //'CN' => 'required',
            'O' => 'required',
            'OU' => 'optional',
            'L' => 'required',
            'SP' => 'optional',
            'C' => 'required',
            'SN' => 'required',
            'BC' => 'required',
            'ST' => 'optional',
            'P' => 'optional',
            'JoILN' => 'optional',
            'JoISoPN' => 'optional',
            'JoISoCN' => 'required'
        ),
        "premium_ev_multidomain_ssl" => array(
            //'CN' => 'required',
            'O' => 'required',
            'OU' => 'optional',
            'L' => 'required',
            'SP' => 'optional',
            'C' => 'required',
            'SN' => 'required',
            'BC' => 'required',
            'ST' => 'optional',
            'P' => 'optional',
            'JoILN' => 'optional',
            'JoISoPN' => 'optional',
            'JoISoCN' => 'required'
        ),
        "open_source_developer" => array('O' => 'required','OU' => 'optional','C' => 'required','E' => 'optional'),
        "standard_code_signing" => array('O' => 'required','OU' => 'optional','C' => 'required','E' => 'optional'),
        "microsoft_code_signing" => array('O' => 'required','OU' => 'optional','C' => 'required','E' => 'optional'),
        "professional_id" => array('O' => 'required','OU' => 'required','C' => 'required','E' => 'required'),
        "enterprise_id" => array('O' => 'required','OU' => 'required','L'=>'optional','SP'=>'optional','C' => 'required','E' => 'required'),
        "basic_id" => array('C' => 'required','E' => 'optional'),
    );
    protected $products    = array(
        "open_source_developer" => array(
            365 => array(
                821 => 1
            ),
        ),
        "standard_code_signing" => array(
            365 => array(
                841 => 1,
                846 => 1
            ),
            730 => array(
                842 => 1,
                847 => 1,
            ),
            1095 => array(
                843 => 1,
                848 => 1,
            ),
        ),
        "microsoft_code_signing" => array(
             365 => array(
                851 => 1
            ),
            730 => array(
                852 => 1,
            ),
            1095 => array(
                853 => 1,
            ),
        ),
        "commercial_ssl" => array(
            365 => array(
                601 => 1,
                606 => 1
            ),
            730 => array(
                602 => 1,
                607 => 1
            ),
            1095 => array(
                603 => 1,
                608 => 1
            ),
        ),
        "commercial_wildcard" => array(
            365 => array(
                741 => 1,
                746 => 1
            ),
            730 => array(
                742 => 1,
                747 => 1
            ),
            1095 => array(
                743 => 1,
                748 => 1
            ),
        ),
        "commercial_multidomain_ssl" => array(
            365 => array(
                651 => 4,
                656 => 4,
                661 => 6,
                666 => 6,
                671 => 10,
                676 => 10,
                961 => 100,
                966 => 100
            ),
            730 => array(
                652 => 4,
                657 => 4,
                662 => 6,
                667 => 6,
                672 => 10,
                677 => 10,
                962 => 100,
                967 => 100
            ),
            1095 => array(
                653 => 4,
                658 => 4,
                663 => 6,
                668 => 6,
                673 => 10,
                678 => 10,
                963 => 100,
                968 => 100
            ),
        ),
        "trusted_ssl" => array(
            365 => array(
                631 => 1,
                636 => 1
            ),
            730 => array(
                632 => 1,
                637 => 1
            ),
            1095 => array(
                633 => 1,
                638 => 1
            ),
        ),
        "trusted_wildcard_ssl" => array(
            365 => array(
                681 => 1,
                686 => 1
            ),
            730 => array(
                682 => 1,
                687 => 1
            ),
            1095 => array(
                683 => 1,
                688 => 1
            ),
        ),
        "trusted_multidomain_ssl" => array(
            365 => array(
                751 => 4,
                756 => 4,
                761 => 6,
                766 => 6,
                771 => 10,
                776 => 10,
                971 => 100,
                976 => 100
            ),
            730 => array(
                752 => 4,
                757 => 4,
                762 => 6,
                767 => 6,
                772 => 10,
                777 => 10,
                972 => 100,
                977 => 100
            ),
            1095 => array(
                753 => 4,
                758 => 4,
                763 => 6,
                768 => 6,
                773 => 10,
                778 => 10,
                973 => 100,
                978 => 100
            ),
        ),
        "test_ssl" => array(
            30 => array(
                691 => 1
            )
        ),
        "premium_ev_ssl" => array(
            365 => array(
                641 => 1,
                646 => 1
            ),
            730 => array(
                642 => 1,
                647 => 1
            )
        ),
        "premium_ev_multidomain_ssl" => array(
            365 => array(
                861 => 4,
                866 => 4,
                871 => 6,
                876 => 6,
                881 => 10,
                886 => 10,
                981 => 100,
                986 => 100
            ),
            730 => array(
                862 => 4,
                867 => 4,
                872 => 6,
                877 => 6,
                882 => 10,
                887 => 10,
                982 => 100,
                987 => 100
            )
        ),
        "spacessl_domain_validation" => array(
            365 => array(
                261 => 1,
                266 => 1
            ),
            730 => array(
                262 => 1,
                267 => 1
            ),
            1095 => array(
                263 => 1,
                268 => 1
            ),
        ),
        "spacessl_wildcard" => array(
            365 => array(
                271 => 1,
                276 => 1
            ),
            730 => array(
                272 => 1,
                277 => 1
            ),
            1095 => array(
                273 => 1,
                278 => 1
            ),
        ),
        "spacessl_multidomain" => array(
            365 => array(
                211 => 4,
                216 => 4,
                221 => 6,
                226 => 6,
                231 => 10,
                236 => 10,
                241 => 100,
                246 => 100
            ),
            730 => array(
                212 => 4,
                217 => 4,
                222 => 6,
                227 => 6,
                232 => 10,
                237 => 10,
                242 => 100,
                247 => 100
            ),
            1095 => array(
                213 => 4,
                718 => 4,
                223 => 6,
                228 => 6,
                233 => 10,
                238 => 10,
                243 => 100,
                248 => 100
            ),
        ),
        "professional_id" => array(
            365 => array(
                711 => 1,
                716 => 1,
            ),
            730 => array(
                712 => 1,
                717 => 1
            ),
            1095 => array(
                713 => 1,
                718 => 1
            ),
        ),
        "enterprise_id" => array(
            365 => array(
                721 => 1,
                726 => 1,
            ),
            730 => array(
                722 => 1,
                727 => 1
            ),
            1095 => array(
                723 => 1,
                728 => 1
            ),
        ),
        "basic_id" => array(
            365 => array(
                731 => 1,
                736 => 1,
            ),
            730 => array(
                732 => 1,
                737 => 1
            ),
            1095 => array(
                733 => 1,
                738 => 1
            ),
        ),
    );

    public function getDomainsByProductCode($productCodeFromToken)
    {
        foreach ($this->products as $productName => $productDays) {
            foreach ($productDays as $productDay => $productParams) {
                foreach ($productParams as $productCode => $productDomains) {
                    if ($productCode == (int) $productCodeFromToken) {
                        return $productDomains;
                    }
                }
            }
        }
        return false;
    }

    public function getProductTypeByCode($productCodeFromToken)
    {
        foreach ($this->products as $productName => $productDays) {
            foreach ($productDays as $productDay => $productParams) {
                foreach ($productParams as $productCode => $productDomains) {
                    if ($productCode == (int) $productCodeFromToken) {
                        return $productName;
                    }
                }
            }
        }
        return false;
    }
}