<?php
/**
 * Partner API Library
 * 
 * @copyright Copyright (c) 2013-2014 Unizeto Technologies SA
 * @license license.txt
 */

//require_once 'type.php';

/*
    <xs:complexType name="validityPeriod">
        <xs:sequence>
            <xs:element name="notAfter" type="xs:date"/>
            <xs:element name="notBefore" type="xs:date"/>
        </xs:sequence>
    </xs:complexType>
*/

/**
 * This class represents the "validityPeriod" WSDL type.
 * 
 * It is based on the PartnerAPIType class and derives some properties and methods from that class.
 * 
 * Both notAfter element and notBefore element are passed as strings
 * but contain dates and therefore they have to be properly passed
 * as functions' arguments.
 * The correct format is YYYY-MM-DD where YYYY is a year, MM is a month and
 * DD is a day of the month. The number of letters indicates the number of digits.
 * 
 * @method PartnerAPITypeValidityPeriod setNotAfter(string $value The notAfter date to be set) Sets the "notAfter" element
 * @method string getNotAfter() Gets the "notAfter" element
 * @property string $notAfter Gets the "notAfter" element
 * 
 * @method PartnerAPITypeValidityPeriod setNotBefore(string $value The notBefore date to be set) Sets the "notBefore" element
 * @method string getNotBefore() Gets the "notBefore" element
 * @property string $notBefore Gets the "notBefore" element
 * 
 * @package types
 * @since 1.3.0
 */
class PartnerAPITypeValidityPeriod extends PartnerAPIType {
    
    protected function initData() {
        return array(
            'notAfter'  => array('min' => 1, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'notBefore' => array('min' => 1, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE)
        );
    }

}
