<?php
/*
 * * ******************************************************************
 *
 *   CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *   AUTHOR                         ->     dariusz.bi@modulesgarden.com
 *   CONTACT                        ->       contact@modulesgarden.com
 *
 *  This software is furnished under a license and may be used and copied
 *  only  in  accordance  with  the  terms  of such  license and with the
 *  inclusion of the above copyright notice.  This software  or any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and  ownership of the  software is  hereby
 *  transferred.
 *
 * * ******************************************************************
 */

class DirectadminLocalAPIDriver extends AbstractLocalAPIDriver
{
    public $clientUsername;
    private $api;

    function __construct($params)
    {
        parent::__construct($params);
        $this->api            = new DirectadminApiDomainsDriver();
        $this->clientUsername = $this->getCurrentUser();
    }

    //connects to api:
    public function _connect($params)
    {

    }

    public function getEmail($userName)
    {
        return $this->api->getEmail($userName);
    }

    //lists users with their accounts
    public function getAccounts()
    {
        return $this->api->getAllAccount();
    }

    //gets current logged in user
    function getCurrentUser()//	CMD_API_GET_SESSION ???
    {
        return $_SERVER['USERNAME'];
    }

    //gets current logged in user language
    function getCurrentLang() // CMD_API_SHOW_USERS , CMD_API_SHOW_ALL_USERS 
    {
        return $_SERVER['LANGUAGE'];
    }

    //generate csr/keys on certificate submit and reissue actions
    function generateCsr($params = null) // http://help.directadmin.com/item.php?id=256
    {
        $generateKeyResult = $this->api->generateSSL(
            $params['country'], $params['state'], $params['city'], $params['OrganizationName'], $params['organisation_unit'], $params['domain'], $params['email'],$params['reissue']
        );

        $generateKeyResult['details'] = array(
            'country' => $params['country'],
            'state' => $params['state'],
            'city' => $params['city'],
            'OrganizationName' => $params['OrganizationName'],
            'organisation_unit' => $params['organisation_unit'],
            'domain' => $params['domain'],
            'email' => $params['email']
        );
        
        return $generateKeyResult;
    }

    function getDomainCertyficate($domain)
    {

        $certificate = $this->api->getCertificate($domain);

        if (!empty($certificate)) {
            return $certificate;
        }

        return false;
    }

    //adds certificate to desired domain - my name
    function installCrt($user, $domain, $privateKey, $certificate)
    {
        return $this->api->saveSSL($user, $domain, $privateKey, $certificate);
    }

    //adds file to domain
    function addsFileToDomain()
    {//http://192.168.2.15:2222/CMD_FILE_MANAGER/domains/testdomain.pl/public_html ???
    }

    //gets user domains list
    function getUserDomains($user = null, $main = null, $userid = null)
    {
        //CMD_API_SHOW_USER_DOMAINS
        //CMD_API_PACKAGES_USER
        //CMD_API_SHOW_DOMAINS
        //CMD_API_SUBDOMAINS
        return $this->api->getAllDomains(array('searchUsername' => $this->clientUsername));
    }

    //	CMD_API_DATABASES - create database
    function getDomainRoot($user, $domain)
    {
        return "/home/$user/domains/$domain/public_html";
    }
}