<?php

/* 
 * * ******************************************************************
 *
 *   CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *   AUTHOR                         ->     dariusz.bi@modulesgarden.com
 *   CONTACT                        ->       contact@modulesgarden.com
 *
 *  This software is furnished under a license and may be used and copied
 *  only  in  accordance  with  the  terms  of such  license and with the
 *  inclusion of the above copyright notice.  This software  or any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and  ownership of the  software is  hereby
 *  transferred.
 *
 * * ******************************************************************
 */

class Modules_Certum_Form_CertificateInstall extends Zend_Form
{   
    public static function get($token, $domain, $approverList, $countries, $approver = null, $aprroverListShow = false, $postData = null)
    {
        $createCertForm = new pm_Form_Simple();
 
        $createCertForm->setAction('/modules/CertumSSL/index.php/client/savecert')->setMethod('post')
            ->addElement('text'  , 'cert_order_token2'    ,array('label' => pm_Locale::lmsg('cert_order_token'),'value' => $token,'attribs' => array('disabled' => 'disabled'), 'size' => 32))
            ->addElement('hidden'  , 'cert_order_token'   ,array('value' => $token,));
            
            if($domain['maxDomains']>1){
                $createCertForm->addElement('select', 'cert_domain_id[]',array('label' => pm_Locale::lmsg('cert_domain'),'multiOptions' => $domain['domainList'],  'multiple' => 'multiple'));
            } else {
                $createCertForm->addElement('select', 'cert_domain_id',array('label' => pm_Locale::lmsg('cert_domain'),'multiOptions' => $domain['domainList'], 'value' => $postData['cert_domain_id']));
            }


        $SSLProducts    = new SSLProducts();
        $productsFields = $SSLProducts->productsFields;
        $productFields  = $productsFields[$domain['productType']];
        $fields         = $SSLProducts->fields;
        $createCertForm->addElement(
            'SimpleText',
            'cert_certdetails' ,
            array(
                'label' => pm_Locale::lmsg('cert_certdetails')
            )
        );
        if (!empty($productFields)) {
            $require = false;
            foreach ($productFields as $productFieldShortcut => $productFieldStatus) {

                $fieldParams = $fields[$productFieldShortcut];

                if ($productFieldStatus == 'required') {
                    $require = true;
                } else {
                    $require = false;
                }

                if ($fieldParams['name'] == 'country') {
                    $createCertForm->addElement(
                        'select',
                        'certdetails_'.$fieldParams['name'] ,
                        array(
                            'label' => pm_Locale::lmsg('cert_org_address_country'),
                            'required' => $require ,
                            'multiOptions'=> $countries,
                            'value' => $postData['cert_certdetails_'.$fieldParams['name']]
                        )
                    );
                } else {
                    $createCertForm->addElement(
                        'text',
                        'certdetails_'.$fieldParams['name'] ,
                        array(
                            'label' => pm_Locale::lmsg('cert_certdetails_'.$fieldParams['name']),
                            'required' => $require ,
                            'value' => $postData['cert_certdetails_'.$fieldParams['name']]
                        )
                    );
                }
            }
        }

        $createCertForm->addElement('SimpleText', 'contact_head', array('label' => pm_Locale::lmsg('contact_head')))
        ->addElement('text', 'contact_first_name', array('label' => pm_Locale::lmsg('cert_contact_first_name'),'required' => true,'value' => $postData['cert_contact_first_name'], 'size' => 32))
        ->addElement('text', 'contact_last_name' , array('label' => pm_Locale::lmsg('cert_contact_last_name'),'required' => true,'value' => $postData['cert_contact_last_name'], 'size' => 32))
        ->addElement('text', 'cert_org_address_email', array('label' => pm_Locale::lmsg('cert_org_address_email'), 'required' => true,'value' => $postData['cert_org_address_email'], 'size' => 32, 'validators' => array(array('EmailAddress'))))
        ->addElement('text', 'cert_org_address_line1', array('label' => pm_Locale::lmsg('cert_org_address_line1'), 'required' => true,'value' => $postData['cert_org_address_line1'], 'size' => 32))
        ->addElement('text', 'cert_org_postalcode', array('label' => pm_Locale::lmsg('cert_org_postalcode'),'required' => true,'value' => $postData['cert_org_postalcode'], 'size' => 32))
        ->addElement('text', 'cert_org_address_city', array('label' => pm_Locale::lmsg('cert_org_address_city'),'required' => true,'value' => $postData['cert_org_address_city'], 'size' => 32))
        ->addElement('select', 'cert_org_address_country', array('label' => pm_Locale::lmsg('cert_org_address_country'),'required' => true ,'multiOptions'=> $countries,'value' => $postData['cert_org_address_country']))
        ->addElement('text', 'cert_org_address_phone', array('label' => pm_Locale::lmsg('cert_org_address_phone'), 'required' => true,'value' => $postData['cert_org_address_phone'], 'size' => 32))
        ->addElement('text', 'cert_org_name', array('label' => pm_Locale::lmsg('cert_org_name'),'required' => false,'value' => $postData['cert_org_name'], 'size' => 32))
        ->addElement('text', 'cert_org_taxid', array('label' => pm_Locale::lmsg('cert_org_taxid'),'required' => false,'value' => $postData['cert_org_taxid'], 'size' => 32))
        ->addElement('text', 'cert_org_verifiphonenumber', array('label' => pm_Locale::lmsg('cert_org_verifiphonenumber'),'required' => false,'value' => $postData['cert_org_verifiphonenumber'], 'size' => 32));

        $createCertForm->addControlButtons(array('cancelLink' => pm_Context::getBaseUrl().'index.php/client/index/index'));
        return $createCertForm; 
    }
}
