<?php

/* 
 * * ******************************************************************
 *
 *   CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *   AUTHOR                         ->     dariusz.bi@modulesgarden.com
 *   CONTACT                        ->       contact@modulesgarden.com
 *
 *  This software is furnished under a license and may be used and copied
 *  only  in  accordance  with  the  terms  of such  license and with the
 *  inclusion of the above copyright notice.  This software  or any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and  ownership of the  software is  hereby
 *  transferred.
 *
 * * ******************************************************************
 */

class Modules_Certum_Form_Reissue extends Zend_Form 
{
    public static function get($token, $domain, $approverList, $countries, $approver = null, $aprroverListShow = false, $postData = null){
        $reissueForm = new pm_Form_Simple();
        $reissueForm->setAction('/modules/CertumSSL/index.php/client/savereissue')->setMethod('post')
            ->addElement('text'     , 'cert_order_token2'   , array('label' => pm_Locale::lmsg('cert_order_token'),'value' => $token,'attribs' => array('disabled' => 'disabled'), 'size' => 32))
            ->addElement('text'     , 'cert_domain2'        , array('label' => pm_Locale::lmsg('cert_domain'),'value' => $domain['name'],'attribs' => array('disabled' => 'disabled'), 'size' => 32))
            ->addElement('hidden'   , 'cert_order_token'    , array('value' => $token))
            ->addElement('hidden'   , 'cert_domain'         , array('value' => $domain['name']))
            ->addElement('hidden'   , 'cert_domain_id'      , array('value' => $domain['id']));

            $reissueForm->addElement('text'     , 'cert_reissue_email'  , array('label' => pm_Locale::lmsg('cert_reissue_email'), 'required' => true,'value' => $postData['cert_reissue_email'], 'size' => 32))
            ->addElement('SimpleText', 'org_contact_head'       ,array('label' => pm_Locale::lmsg('org_contact_head')))
            ->addElement('text'      , 'cert_org_name'          ,array('label' => pm_Locale::lmsg('cert_org_name'), 'required' => true,'value' => $postData['cert_org_name'], 'size' => 32))
            ->addElement('text'      , 'cert_org_postalcode'    ,array('label' => pm_Locale::lmsg('cert_org_postalcode'), 'required' => true,'value' => $postData['cert_org_postalcode'], 'size' => 32))
            ->addElement('text'      , 'cert_org_address_city'  ,array('label' => pm_Locale::lmsg('cert_org_address_city'), 'required' => true,'value' => $postData['cert_org_address_city'], 'size' => 32))
            ->addElement('text'      , 'cert_org_address_region',array('label' => pm_Locale::lmsg('cert_org_address_region'), 'required' => true,'value' => $postData['cert_org_address_region'], 'size' => 32))
            ->addElement('select', 'cert_org_address_country',array('label' => pm_Locale::lmsg('cert_org_address_country'),'multiOptions'=> $countries,'value'=>$postData['cert_org_address_country'], 'required' => true,))
            ->addElement('text'  , 'cert_org_address_email'  ,array('label' => pm_Locale::lmsg('cert_org_address_email'), 'required' => true,'value' => $postData['cert_org_address_email'], 'size' => 32))
            ->addElement('text'  , 'cert_org_address_line1'  ,array('label' => pm_Locale::lmsg('cert_org_address_line1'), 'required' => true,'value' => $postData['cert_org_address_line1'], 'size' => 32))
            ->addElement('text'  , 'cert_org_address_line2'  ,array('label' => pm_Locale::lmsg('cert_org_address_line2'), 'required' => true,'value' => $postData['cert_org_address_line2'], 'size' => 32))
            ->addElement('text'  , 'cert_org_address_phone'  ,array('label' => pm_Locale::lmsg('cert_org_address_phone'), 'required' => true,'value' => $postData['cert_org_address_phone'], 'size' => 32))
            ->addControlButtons(array('cancelLink' => pm_Context::getBaseUrl().'index.php/client/index/index'));

            return $reissueForm;
    }
}
