<?php
/*
 * * ******************************************************************
 *
 *   CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *   AUTHOR                         ->     dariusz.bi@modulesgarden.com
 *   CONTACT                        ->       contact@modulesgarden.com
 *
 *  This software is furnished under a license and may be used and copied
 *  only  in  accordance  with  the  terms  of such  license and with the
 *  inclusion of the above copyright notice.  This software  or any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and  ownership of the  software is  hereby
 *  transferred.
 *
 * * ******************************************************************
 */

define("DS", DIRECTORY_SEPARATOR);

require DS.'opt'.DS.'psa'.DS.'admin'.DS.'plib'.DS.'modules'.DS.'CertumSSL'.DS.'core'.DS.'CertumSSLLoader.php';

class Modules_CertumSSL_RecentlyMainCron
{
    private $main;

    public function load()
    {
        $this->main = new CertumSSLMainController('Plesk', '/opt/psa/admin/plib/modules/CertumSSL');
        $this->recentlycronAction();
    }

    function recentlycronAction()
    {
        $parentsCertOrders = new MGCertOrders(array('_tableName' => 'certumssl_orders'));
        $parentsOrder      = $parentsCertOrders->getAllOrders();

        foreach ($parentsOrder as $parentOrder) {
            $domain         = "";
            $domainRootName = "";
            $notification   = new MGNotification();

            $domainsParams = CertumSSLDriver::localAPI()->getUserDomains(null, null, $parentOrder['user_id']);

            foreach ($domainsParams as $domainParam) {
                if ($domainParam['domain'] == $parentOrder['domain_id']) {
                    $domain   = $parentOrder['domain_id'];
                    $domainId = $domainParam['domainid'];
                }
            }

            if ($domain != "") {
                $taskParams         = array();
                $task               = new MGCronTask(array('_tableName' => 'certumssl_cron_tasks'));
                $task->orderId      = $parentOrder['order_id'];
                $task->userId       = $parentOrder['user_id'];
                $task->domainId     = $parentOrder['domain_id'];
                $task->activateDate = '0000-00-00 00:00:00';
                $taskParams         = $task->getTaskByOrderId($parentOrder['order_id']);

                if (empty($taskParams)) {
                    $task->create();
                }

                $task->updateLastTry();
                $userEmail            = CertumSSLDriver::localAPI()->getUserEmailById($parentOrder['user_id']);
                $adminEmailNotifySend = array();
                $adminEmailNotifySend = $task->passDaysFromLastNotify(1);

                $notifySended = false;

                if (!$task->fileExist() && $parentOrder['file_name'] != "" && $parentOrder['file_content'] != "") {
                    // File creation mod
                    $fileToCreate   = 'certum.txt';
                    $fileContent    = $parentOrder['file_content'].'-certum.pl';

                    $domainRootPath = CertumSSLDriver::localAPI()->getDomainRootPath($domainId);

                    $createInstallFile = pm_ApiCli::callSbin('saveFile',
                            array('-domainpath:'.$domainRootPath.DS.'.well-known'.DS.'pki-validation'.DS, '-filename:'.$fileToCreate, '-filecontent:'.$fileContent));

                    if (!file_exists($domainRootPath.DS.$fileToCreate)) {
                        if (!empty($adminEmailNotifySend)) {
                            $adminNotifyFailureSubject = 'Installation of Client Certificate Failed';
                            $op_domainPArams           = CertumSSLDriver::localAPI()->getUserDomainById($domainId);
                            $adminFailureNotifyMessage = $this->buildAdminNotifyMessage(
                                $adminNotifyFailureSubject, CertumSSLDriver::localAPI()->getUserNameById($adminEmailNotifySend['user_id']), $userEmail, $op_domainPArams['name'],
                                $parentOrder["order_id"], $parentOrder['used_voucher']
                            );

                            $notification->adminSummary($adminNotifyFailureSubject, $adminFailureNotifyMessage);
                            $notifySended = true;
                        } else {
                            $task->updateFileExist(1);
                            $certificate          = new CertumSSLCertificate();
                            $certificate->userId  = $parentOrder['user_id'];
                            $certificate->orderId = $parentOrder["order_id"];
                            $certificate->verifyDomain($parentOrder['file_name'], $parentOrder['rel_id']);
                            $parentsCertOrders->updateFileCreated($parentOrder["order_id"], 1);
                        }
                    } else {
                        $certificate          = new CertumSSLCertificate();
                        $certificate->userId  = $parentOrder['user_id'];
                        $certificate->orderId = $parentOrder["order_id"];
                        $certificate->verifyDomain($parentOrder['file_name'], $parentOrder['rel_id']);
                        $parentsCertOrders->updateFileCreated($parentOrder["order_id"], 1);
                        $task->updateFileExist(1);
                    }
                }
            }
        }

        $notInstalledOrders = $parentsCertOrders->getAllNotFinishedOrders();

        foreach ($notInstalledOrders as $key => $OrderToInstall) {
            if (!isset($OrderToInstall['domain_id']) && isset($OrderToInstall['parent_id'])) {
                $OrderToInstall = array_merge($OrderToInstall, $parentsCertOrders->getParentParams($OrderToInstall['parent_id']));
            }
            $notInstalledOrders[$key] = $OrderToInstall;
        }

        foreach ($notInstalledOrders as $notInstalledOrder) {
            if (!empty($notInstalledOrder[0])) {
                foreach ($notInstalledOrder[0] as $key => $val) {
                    $notInstalledOrder[$key] = $val;
                }
                unset($notInstalledOrder[0]);
            }

            $domain         = "";
            $domainRootName = "";
            $notification   = new MGNotification();
            $domainsParams  = CertumSSLDriver::localAPI()->getUserDomains(null, null, $notInstalledOrder['user_id']);

            foreach ($domainsParams as $domainParam) {
                if ($domainParam['domain'] == $notInstalledOrder['domain_id']) {
                    $domain   = $notInstalledOrder['domain_id'];
                    $domainId = $domainParam['domainid'];
                }
            }

            if ($domain != "") {

                $taskParams         = array();
                $task               = new MGCronTask(array('_tableName' => 'certumssl_cron_tasks'));
                $task->orderId      = $notInstalledOrder['order_id'];
                $task->userId       = $notInstalledOrder['user_id'];
                $task->domainId     = $notInstalledOrder['domain_id'];
                $task->activateDate = '0000-00-00 00:00:00';
                $taskParams         = $task->getTaskByOrderId($notInstalledOrder['order_id']);

                if (empty($taskParams)) {
                    $task->create();
                }
                $task->updateLastTry();

                $clientAccount      = new CertumSSLAccount($notInstalledOrder['user_id']);
                $orderDetailsParams = array('orderid' => $notInstalledOrder['order_id']);

                $orderDetails = $clientAccount->orderDetails($orderDetailsParams);
                $domainName   = CertumSSLDriver::localAPI()->getUserDomainById($domainId);
                $userAccounts = CertumSSLDriver::localAPI()->getAccounts();
                $userEmail    = CertumSSLDriver::localAPI()->getUserEmailById($notInstalledOrder['user_id']);

                foreach ($orderDetails as $orderDetail) {
                    if ($orderDetail["orderdefault"]["orderID"] == $notInstalledOrder['order_id'] && isset($orderDetail['cert']['X509Cert'])) {
                        $installCrt = "Error";
                        $CRT        = "-----BEGIN CERTIFICATE-----\n".$orderDetail['cert']['X509Cert']."\n-----END CERTIFICATE-----";
                        $CRT_CA     = null;

                        if ($CRT != null) {
                            $installCrt = CertumSSLDriver::localAPI()->installCrt($domainName['name'], $notInstalledOrder['used_csr'], $notInstalledOrder['csr_key'], $CRT, null,
                                $notInstalledOrder['order_id']);
                        }

                        if ($installCrt !== true || $installCrt === "Error") {

                            $adminEmailNotifySend = array();
                            $adminEmailNotifySend = $task->passDaysFromLastNotify(1);
                            $error                = $installCrt;

                            if (!empty($adminEmailNotifySend)) {
                                $adminNotifyFailureSubject = 'Failed install certificate';

                                $adminFailureNotifyMessage = $this->buildAdminNotifyMessage(
                                    $adminNotifyFailureSubject, CertumSSLDriver::localAPI()->getUserNameById($notInstalledOrder['user_id']), $userEmail, $domainName['name'],
                                    $notInstalledOrder['order_id'], $notInstalledOrder['used_voucher'], $error
                                );
                                $notification->adminSummary($adminNotifyFailureSubject, $adminFailureNotifyMessage);
                                $notifySended              = true;
                            }
                        } else {
                            CertumSSLDriver::localAPI()->enableSSL($domain['name']);

                            if ($notInstalledOrder['order_id'][0] == '_' && $notInstalledOrder['order_id'][strlen($notInstalledOrder['order_id']) - 1] == '_') {
                                $reissueOrders = new MGReissuedOrders(array('_tableName' => 'certumssl_reissued_orders', 'orderId' => $notInstalledOrder['order_id']));
                                $reissueOrders->setFinished(1);
                            } else {
                                $parentOrder = new MGCertOrders(array('_tableName' => 'certumssl_orders', 'orderId' => $notInstalledOrder['order_id']));
                                $parentOrder->setFinished(1);
                            }

                            $adminNotifySubject = pm_Locale::lmsg('raportTitle');
                            try {
                                $notification->userSuccessInstallCertificate($userEmail, array('{$domain}', '{$certificate_id}', '{$voucher_code}'),
                                    array($domainName['name'], $notInstalledOrder['order_id'], $notInstalledOrder['used_voucher']));

                                $adminNotifyMessage = $this->buildAdminNotifyMessage(
                                    $adminNotifySubject, CertumSSLDriver::localAPI()->getUserNameById($notInstalledOrder['user_id']), $userEmail, $domainName['name'], $notInstalledOrder["order_id"],
                                    $notInstalledOrder['used_voucher'], null, 'success'
                                );

                                $notification->adminSummary($adminNotifySubject, $adminNotifyMessage);
                                $task->userId       = $notInstalledOrder['user_id'];
                                $task->domainId     = $notInstalledOrder['domain_id'];
                                $task->activateDate = date('Y-m-d H:i:s');
                                $task->setFinished();
                            } catch (Exception $ex) {
                                MGExceptionLogger::addLog(null, null, $ex);
                            }
                        }
                        if ($notifySended) {
                            $task->updateAdminNotifyDate();
                        }
                    }
                }
            }
        }
    }

    public function buildAdminNotifyMessage($title, $clientName, $clientEmail, $clientDomain, $certCenterOrderId, $voucherCode, $errorMessage = null, $type = 'failure')
    {
        if ($type == 'success') {
            $adminNotifyMessage = "<html>
                <head>
                    <title>".$title."</title>
                </head>
                <body>
                <h4>Client {$clientName} successfully installed certificate</h4>
                    On Domain: <b>{$clientDomain}</b>, <br>
                    Certum Order ID: <b>{$certumOrderId}</b>,<br>
                    Used Voucher Code: <b>{$voucherCode}</b> ,<br>
                    Client Email: <b>{$clientEmail}
                </body>
            </html>";
        } else {
            $adminNotifyMessage = "<html>
                <head>
                    <title>".$title."</title>
                </head>
                <body>
                <h4>Creating required files for the domain: {$clientDomain} failed.</h4>

                    Client: <b>{$clientName}</b>, <br>
                    Client Email: <b>{$clientEmail}</b>, <br>
                    Certum Order ID: <b>{$certumOrderId}</b>,<br>
                    Used Voucher Code: <b>{$voucherCode}</b><br>";
            if ($errorMessage) {
                $adminNotifyMessage .= "Recived Error Message: ".$errorMessage;
            }
            $adminNotifyMessage .=
                "</body>
            </html>";
        }
        return $adminNotifyMessage;
    }
}
