<?php

/* 
 * * ******************************************************************
 *
 *   CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *   AUTHOR                         ->     dariusz.bi@modulesgarden.com
 *   CONTACT                        ->       contact@modulesgarden.com
 *
 *  This software is furnished under a license and may be used and copied
 *  only  in  accordance  with  the  terms  of such  license and with the
 *  inclusion of the above copyright notice.  This software  or any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and  ownership of the  software is  hereby
 *  transferred.
 *
 * * ******************************************************************
 */
//ini_set('error_reporting', E_ALL);
//error_reporting(-1);
ini_set("display_errors", 1);

define("DS",DIRECTORY_SEPARATOR);
define("CERTCENTERSSL_INCLUDES",'/opt/psa/admin/plib/modules/CertumSSL/core/');
require_once CERTCENTERSSL_INCLUDES.'CertumSSLLoader.php';
require_once '/opt/psa/admin/plib/modules/CertumSSL/library/CertumSSLHelper.php';
require_once '/opt/psa/admin/plib/modules/CertumSSL/library/Form/Modules_Certum_Form_CertificateInstall.php';
require_once '/opt/psa/admin/plib/modules/CertumSSL/library/Form/Modules_Certum_Form_Reissue.php';
require_once '/opt/psa/admin/plib/modules/CertumSSL/library/Form/Modules_Certum_Form_InstallNewCertificate.php';



class ClientController extends pm_Controller_Action
{
    private $main;
    private $session;
    private $account;
    private $clientUsername;
    private $helper;
    
    public function init()
    {
        parent::init();
        $this->db = pm_Bootstrap::getDbAdapter();
        $this->session = new \pm_Session;
        $this->view->pageTitle = pm_Locale::lmsg('module_name');
        $this->main = new CertumSSLMainController('Plesk','/opt/psa/admin/plib/modules/CertumSSL');
        $id = $_SESSION['auth']['sessionClientId'];
        $query = $this->db->query('SELECT `login` FROM `clients` WHERE `id`=?', array($id))->fetch();
        $this->clientUsername = $query['login'];
        $this->account = new CertumSSLAccount($_SESSION['auth']['sessionClientId']);
        $this->helper = new CertumSSLHelper();
    }

/**************************** ACTIONS **************************************************************/
    public function indexAction()
    {
        $this->view->noDomains = false;
        
        if($this->session->getClient()->isAdmin()){
            $this->view->adminLogged = true;
            return;
        }

        $this->view->certs  = $this->account->getCerts();

        $this->view->list   = $this->getCertList($this->view->certs);

        $domainList = array();
        foreach ($this->account->getDomains() as $domain){
            $domainList[$domain->domainid] = $domain->domain;
        }
        
        
        if(empty($domainList)){
            $this->view->noDomains = true;
        }

        $this->view->domainList             = $domainList;
        $this->view->tabPageTitle           = pm_Locale::lmsg('client_module_name');
        $this->view->pageTitleNewInstalled  = pm_Locale::lmsg('client_install_new');

        if($this->_getParam('error')){
            
            if($this->_getParam('error') == 'nonevoucher')
            {
                $this->view->error = pm_Locale::lmsg('client_error_nonevoucher');
            } else {
                $this->view->error = $this->_getParam('error');
            }
            
        }
        if($this->view->certs === false){
             $this->view->error = 'Something Goes Wrong, Please Contact Admin';
        }
        if($this->_getParam('cert') && $this->_getParam('cert') == 'success' ){
            $this->view->info = 'Certificate has been successfully saved';
        }
        
        if($this->_getParam('reissue') && $this->_getParam('reissue') == 'success'){
            $this->view->info = 'Certificate has been successfully reissued';
        }

        $installForm = Modules_Certum_Form_InstallNewCertificate::get($domainList);
        $this->view->installForm = $installForm;
        $this->view->billingURL = CertumSSLDriver::config()->billing_url;
        
        if ($this->getRequest()->isPost() && $installForm->isValid($this->getRequest()->getPost())) {
            $this->indexFormSave($installForm);
            $this->_helper->json(array('redirect' => pm_Context::getBaseUrl().'index.php/client/index/'));
        }
    }
    
    public function certAction()
    {
        if($this->_getParam('error')){
            $this->view->error = $this->_getParam('error');
        }

        $certForm = $this->certOrderForm();

        if ($this->getRequest()->isPost() && $certForm->isValid($this->getRequest()->getPost())) {
            $this->certOrderFormSave($certForm);
        }
        
        $this->view->createCertForm = $certForm;
    }

    public function reissueAction()
    {
        $postData = $this->getRequest()->getPost();
        if($this->getRequest()->isPost() && $postData["serialNumber"]){
            $certificate                = new CertumSSLCertificate();
            $certificate->userId        = $_SESSION['auth']['sessionClientId'];
            $certificate->reissueCertyficate($postData["serialNumber"]); 
        }
        
    }
    
    public function ajaxAction()
    {
        if($this->_request->isPost()){
            $postData   = $this->_request->getPost();
            $action     = $postData['action'];
            $token      = $postData['token'];
            $serialNumber = $postData["serialNumber"];
            
            $certificate                = new CertumSSLCertificate();
            $certificate->orderVoucher    = $token;
            $certificate->userId        = $_SESSION['auth']['sessionClientId'];
            $certificate->orderId       = $postData['orderid'];
            
            switch($action){
                case 'Revoke':
                    $certificate->revokeCertOrder($serialNumber,$postData['relid']);

                    if(!empty($certificate->errors)){
                        $errorsArray = $certificate->errors;
                        $this->_helper->json(array('status' => 'error', 'msg' => $errorsArray['revokeCertificate'][0][0]['text'] ));
                        die(); 
                    }
                    
                    $this->_helper->json(array('status' => 'success', 'msg' => pm_Locale::lmsg('client_revoke_success')));
                    die;
                    break;
                    
                case 'Cancel':
                    $response = $certificate->cancelCertOrder($postData['relid']);
                    
                    if(!empty($certificate->errors)){
                        $errorsArray = $certificate->errors;
                        $this->_helper->json(array('status' => 'error', 'msg' => $errorsArray['cancelOrder'][0][0]['text'] ));
                        die(); 
                    }

                    $this->_helper->json(array('status' => 'success', 'msg' => pm_Locale::lmsg('client_cancel_success')));
                    die();                
                    break;
                    
                case 'Reissue':
                    $postData = $this->getRequest()->getPost();
                    if($this->getRequest()->isPost() && $postData["serialNumber"]){
                        $certificate->reissueCertyficate($postData["serialNumber"],$postData['relid']);
                    }

                    if(!empty($certificate->errors)){
                        $errorsArray = $certificate->errors;
                        $this->_helper->json(array('status' => 'error', 'msg' => $errorsArray['reissueCertificate'][0][0]['text'] ));
                        die(); 
                    }

                    $this->_helper->json(array('status' => 'success', 'msg' => pm_Locale::lmsg('client_reissue_success')));
                    die();                
                    break;
                    
                case 'Info':
                    $ordersParams = $certificate->getOrderDetails($postData['relid']);
                    $vars = array();
                    foreach($ordersParams as $orderParam){
                        if($orderParam['orderdefault']['orderID'] == $postData['orderid']){
                            $vars = $orderParam;
                        }
                    }
                    //$domain = CertumSSLDriver::localAPI()->getUserDomainById($postData['domainID']);
                    $vars['orderdefault']['voucherCode'] = $postData['token'];
                    $vars['orderdefault']['domainName']  = $postData['domainID'];
                    $vars['orderdefault']['orderID']     = $postData['orderid'];
                    
                    $this->_helper->json(array('status' => 'success', 'msg' => '','params' => $vars));
                    die();                
                    break;
                    
                case 'cleanlogs':
                        MGAPILogs::cleanAllLogs();
                        $this->_helper->json(array('status' => 'success', 'msg' => pm_Locale::lmsg('logs_cleaned')));
                    break;
                
                case 'changelogstatus':
                        if(CertumSSLDriver::config()->apilogs_turnon_value == 'on'){
                            CertumSSLDriver::config()->apilogs_turnon_value = 'off';
                        }else{
                            CertumSSLDriver::config()->apilogs_turnon_value = 'on';
                        }
                        $this->_helper->json(array('status' => 'success', 'msg' => ''));
                    break;
            }
            $this->_helper->json(array('status' => 'error', 'msg' => pm_Locale::lmsg('client_error_ajax')));
        }
    }
    
    /**************************** FORMS **************************************************************/
    
    private function certOrderForm()
    {
        $aprroverList            = true;
        $postData                = $this->_request->getPost();
        $token                   = $this->_getParam('token')?$this->_getParam('token'):$postData['cert_order_token'];
        $domainId                = $this->_getParam('id')?$this->_getParam('id'):$postData['cert_domain_id'];
        $approver                = $postData['cert_approver_email'];
        $certificate             = new CertumSSLCertificate();
        //$certificate->account    = $this->clientUsername;
        $domainParams            =  CertumSSLDriver::localAPI()->getUserDomainById($domainId);
        //$certificate->domain     = $domainParams['name'];
        $certificate->orderVoucher = $token;
        $countries               = $certificate->getCountries();

        $productCode = $this->account->getProductCodeFromToken($token);
        $SSLProducts = new SSLProducts();
        $countDomains = $SSLProducts->getDomainsByProductCode($productCode);
        $domainList = array();

        foreach ($this->account->getDomains() as $domain) {
            $domainList[$domain->domainid] = $domain->domain;
        }
        $sslProductType = $SSLProducts->getProductTypeByCode($productCode);
        $formParams = array('domainList' => $domainList,"maxDomains" => $countDomains,'productType' => $sslProductType);
        
        return Modules_Certum_Form_CertificateInstall::get($token, $formParams, $certificate->getApproverList(), $countries, array(),false, $postData);   
    }
    
    private function reissueOrderForm()
    {
        $postData                = $this->_request->getPost();
        $token                   = $this->_getParam('token')?$this->_getParam('token'):$postData['cert_order_token'];
        $domainId                = $this->_getParam('id')?$this->_getParam('id'):$postData['cert_domain_id'];
        $approver                = $postData['cert_approver_email'];
        $certificate             = new CertumSSLCertificate();
        //$certificate->account    = $this->clientUsername;
        $domainParams            = CertumSSLDriver::localAPI()->getUserDomainById($domainId);
        //$certificate->domain     = $domainParams['name'];
        $certificate->orderVoucher = $token;
        $countries               = $certificate::getCountries();
        $voucherdvMethods        = $certificate->getVoucherDVMethod();
        foreach($voucherdvMethods as $voucherdvMethod){
            if($voucherdvMethod == 'DV' || $voucherdvMethod == 'OV' || $voucherdvMethod == 'EV'){
                $aprroverList = false;
            }
        }
        return Modules_Certum_Form_Reissue::get($token, $domainParams, $certificate->getApproverList(), $countries, $approver,$aprroverList, $postData);   
    }
    
/**************************** FORMS ACTIONS **************************************************************/
    private function indexFormSave($installForm)
    {
        $certificate             = new CertumSSLCertificate();
        $certificate->orderVoucher = $installForm->getValue('cert_order_token');
        
        $productCode = $this->account->getProductCodeFromToken($certificate->orderVoucher);
        
        $SSLProducts = new SSLProducts();
        $countDomains = $SSLProducts->getDomainsByProductCode($productCode);
        
        if($countDomains>1){
            $this->_helper->json(array('redirect' => pm_Context::getBaseUrl().'index.php/client/index/error/notsupport/'));
        }
        
        if(empty($certificate->orderVoucher)){
            $this->_helper->json(array('redirect' => pm_Context::getBaseUrl().'index.php/client/index/error/emptytoken/'));
        }

        if(!$this->account->getStatement($installForm->getValue('cert_order_token'))){
            $this->_helper->json(array('redirect' => pm_Context::getBaseUrl().'index.php/client/index/error/wrongtoken/'));
        }
        
        
        $this->_helper->json(array('redirect' => pm_Context::getBaseUrl().'index.php/client/statement/token/'.$installForm->getValue('cert_order_token').'/'));
    }
    
    public function statementAction(){
        
        $this->view->id = $this->_getParam("id");
        $this->view->token = $this->_getParam("token");

        $this->view->statementText = $this->account->getStatement($this->_getParam("token"));
        if(!empty($this->account->errors["getStatement"])){
            $this->view->error = $this->account->errors["getStatement"][0];
        }
    }
    
    public function savecertAction()
    {
        
        if (!$this->getRequest()->isPost()) {
            return $this->_forward('/modules/CertumSSL/index.php/client/');
        }
        $paramsToValid = $_POST;
        unset($paramsToValid['cert_approver_email']);
        $certForm = $this->certOrderForm();

        if (!$certForm->isValidPartial($paramsToValid)) {
            $this->view->form = $certForm;
            return $this->render('cert');
        }
        
        $this->certOrderFormSave($certForm);
 
        $this->view->createCertForm = $certForm;
    }

    public function savereissueAction()
    {
        if (!$this->getRequest()->isPost()) {
            return $this->_forward('/modules/CertumSSL/index.php/client/');
        }
        
        $paramsToValid = $_POST;
        unset($paramsToValid['cert_approver_email']);
        $reissueForm = $this->reissueOrderForm();
        
        if (!$reissueForm->isValidPartial($paramsToValid)) {
            $this->view->form = $reissueForm;
            return $this->render('reissue');
        }

        $this->reissueFormSave($reissueForm);
        $this->view->reissueForm = $reissueForm;
    }
    
    private function certOrderFormSave($createCertForm)
    {

        $certificate                = new CertumSSLCertificate();
        //$certificate->account       = $this->clientUsername;
        $certificate->userId        = $_SESSION['auth']['sessionClientId'];
        //$certificate->domain        = $createCertForm->getValue('cert_domain');
        $domainParams =  CertumSSLDriver::localAPI()->getUserDomainById($_POST['cert_domain_id']);
        $certificate->domainId      = $domainParams['name'];
        //var_dump( $createCertForm->getValue('cert_domain') );
        
        $certificate->orderVoucher    = $createCertForm->getValue('cert_order_token');
        $certificate->setVoucherProductCode();
        $voucherdvMethods           = $certificate->getVoucherDVMethod();
        
        $productCode = $this->account->getProductCodeFromToken($certificate->orderVoucher);
        $SSLProducts = new SSLProducts();
        $sslProductType = $SSLProducts->getProductTypeByCode($productCode);

        if(!is_array($certificate->domainId) && strpos($sslProductType,"wildcard") !== false ){
            $certificate->domainId = '*.'.$certificate->domainId;
        }else{
            $certificate->domainId = $certificate->domainId;
        }
        
        
        foreach($voucherdvMethods as $voucherdvMethod){
            if($voucherdvMethod == 'DV'){
                $certificate->DVMethod = 'DV';
            }
        }
        
        if($createCertForm->getValue('cert_approver_email') != null){
            $certificate->approverEmail = $createCertForm->getValue('cert_approver_email');
        }

        $certificate->certOrgContacts = $this->helper->certificateInputConditions($createCertForm->getValues());

            $certificate->certContacts = array(
                'firstName'  => $createCertForm->getValue('contact_first_name'),
                'lastName'   => $createCertForm->getValue('contact_last_name'),
                'address'    => $createCertForm->getValue('cert_org_address_line1'),
                'city'       => $createCertForm->getValue('cert_org_address_city'),
                'country'    => $createCertForm->getValue('cert_org_address_country'),
                'email'      => $createCertForm->getValue('cert_org_address_email'),
                'phone'      => $createCertForm->getValue('cert_org_address_phone'),
                'postalCode' => $createCertForm->getValue('cert_org_postalcode'),
                'organisationName'  => $createCertForm->getValue('cert_org_name'),
                'taxNumber'         => $createCertForm->getValue('cert_org_taxid')
            );
            


            $certificate->certDetails = array(
                'organisation' => $createCertForm->getValue('certdetails_organisation'),
                'organisation_unit' => $createCertForm->getValue('certdetails_organisation_unit'),
                'locality' => $createCertForm->getValue('certdetails_locality'),
                'state_province' => $createCertForm->getValue('certdetails_state_province'),
                'country' => $createCertForm->getValue('certdetails_country'),
                'email' => $createCertForm->getValue('certdetails_email'),
                'serial_number' => $createCertForm->getValue('certdetails_serial_number'),
                'business_category' => $createCertForm->getValue('certdetails_business_category'),
                'street_address' => $createCertForm->getValue('certdetails_street_address'),
                'postal_code' => $createCertForm->getValue('certdetails_postal_code'),
                'JoILN' => $createCertForm->getValue('certdetails_JoILN'),
                'JoISoPN' => $createCertForm->getValue('certdetails_JoISoPN'),
                'JoISoCN' => $createCertForm->getValue('certdetails_JoISoCN')
            );
        
            $certificate->taxIdentificationNumber = $createCertForm->getValue('cert_org_taxid');

    try {
            $certificate->generateCSR();
           
            if(!empty($certificate->errors)){
                $errorsArray = $certificate->errors;
                echo $errorsArray;
                die();  
            }

            $certificate->placeCertRequest();
            //$certificate->fakePlaceCertRequest();
             //var_dump($certificate->errors);
            if(!empty($certificate->errors) && array_key_exists('quickOrder',$certificate->errors)){
                $errorsArray = $certificate->errors;
                if($errorsArray['quickOrder']['0']['0']['number'] == 1013) {
                    $this->_helper->json(array('redirect' => pm_Context::getBaseUrl().'index.php/client/index/error/nonevoucher'));
                }
                echo $errorsArray['quickOrder']['0'];
                die();
            }
    }
    catch (\Exception $e){
        echo $e->getMessage();
        die();
    }
        $this->_helper->json(array('redirect' => pm_Context::getBaseUrl().'index.php/client/index/cert/success')); 
    }

    private function reissueFormSave($reissueForm)
    {
        $certificate                = new CertumSSLCertificate();
        //$certificate->account       = $this->clientUsername;
        $certificate->userId        = $_SESSION['auth']['sessionClientId'];
        //$certificate->domain        = $reissueForm->getValue('cert_domain');
        $certificate->domainId      = $reissueForm->getValue('cert_domain_id');
        $certificate->orderVoucher    = $reissueForm->getValue('cert_order_token');
//        $certificate->approverEmail = $reissueForm->getValue('cert_approver_email');
//        $certificate->reissueEmail  = $reissueForm->getValue('cert_reissue_email');
        
        $certificate->certOrgContacts = array(
            'OrganizationName'      => $reissueForm->getValue('cert_org_name')
            ,'company'              => $reissueForm->getValue('cert_org_name')
            ,'companypostalcode'    => $reissueForm->getValue('cert_org_postalcode')
            ,'country'              => $reissueForm->getValue('cert_org_address_country')
            ,'city'                 => $reissueForm->getValue('cert_org_address_city')
            ,'state'                => $reissueForm->getValue('cert_org_address_region')   
            ,'email'                => $reissueForm->getValue('cert_org_address_email')
        );
        
        $certificate->generateCSR();
        //$certificate->validateCSR();

        if(!empty($certificate->errors && array_key_exists('ValidateCSR',$certificate->errors))){
            $errorsArray = $certificate->errors;
            echo $errorsArray['ValidateCSR']['ValidateCSRErrorMessage'];
            die();
        }
        
        $certificate->reissueCertOrder();
          
        if(!empty($certificate->errors && array_key_exists('Reissue',$certificate->errors))){
            $errorsArray = $certificate->errors;
            $this->view->form = $reissueForm;
            echo $errorsArray['Reissue']['ReissueErrorMessage'];
            die();
        }

        $this->_helper->json(array('redirect' => pm_Context::getBaseUrl().'index.php/client/index/reissue/success'));      
    }
    
/**************************** TABLES **************************************************************/
    private function getCertList($certList)
    {
        $data = array();

        foreach($certList as $certToken => $certData){
            
            $actionButtons = '<button type="button" class="btn btn-info btn-xs certcancel" data-token="'.$certData['token'].'" data-action="Info" data-orderid="'.$certData['orderid'].'" data-domainid="'.$certData['domainid'].'" data-relid="'.$certData['relid'].'">Details</button>';
            if(isset($certData['certSerialNumber']) && !$certData['reissued'] && $certData['cert_status'] == 'VALID'){
                $actionButtons .= '<button type="button" class="btn btn-info btn-xs" data-token="'.$certToken.'" data-orderid="'.$certData['orderid'].'" data-certserialnumber="'.$certData['certSerialNumber'].'" data-domainid="'.$certData['domainId'].'" data-action="Reissue" data-relid="'.$certData['relid'].'">Reissue</button>';
            }
            
            if(isset($certData['certSerialNumber']) && $certData['cert_status'] != 'REVOKED' && $certData['cert_status'] != 'REVOKING'){
                $actionButtons .= '<button type="button" class="btn btn-info btn-xs certrevoke" data-token="'.$certToken.'" data-orderid="'.$certData['orderid'].'" data-certserialnumber="'.$certData['certSerialNumber'].'" data-orderid="'.$certData['orderid'].'" data-action="Revoke" data-domainid="'.$certData['domainId'].'" data-relid="'.$certData['relid'].'">Revoke</button>';
            }
            
            if($certData['cert_status'] == 'REVOKED' || $certData['cert_status'] == 'AWAITING'){
                $actionButtons .= '<button type="button" class="btn btn-info btn-xs certcancel" data-token="'.$certToken.'" data-orderid="'.$certData['orderid'].'" data-action="Cancel" data-domainid="'.$certData['domainId'].'" data-relid="'.$certData['relid'].'">Cancel</button>';
            }

            $domainParams = CertumSSLDriver::localAPI()->getUserDomainById($certData['domainid']);
            $data[] = array(
                'column-1' => $certData['certName'],
                'column-2' => isset($certData['serialnumber'])?$certData['serialnumber']:'None',
                'column-3' => $certData['domainid'],
                'column-4' => $certData['activateddate'],
                'column-5' => isset($certData['startDate'])?$certData['startDate']: 'None',
                'column-6' => isset($certData['endDate'])?$certData['endDate']: 'None',
                'column-7' => $certData['cert_status'],
                'column-8' => $certData['status'],
                'column-9' => $actionButtons,
            );
        }

        $list = new pm_View_List_Simple($this->view, $this->_request);
        $list->setData($data);
        $list->setColumns(array(
            'column-1' => array(
                'title' => pm_Locale::lmsg('certname'),
                'noEscape' => true,
            ),
            'column-2' => array(
                'title' => pm_Locale::lmsg('certserialnumber'),
                'noEscape' => true,
            ),
            'column-3' => array(
                'title' => pm_Locale::lmsg('domain'),
                'noEscape' => true,
            ),
            'column-4' => array(
                'title' => pm_Locale::lmsg('certactivateddate'),
                'noEscape' => true,
            ),
            'column-5' => array(
                'title' => pm_Locale::lmsg('certvalidfromdate'),
                'noEscape' => true,
            ),
            'column-6' => array(
                'title' => pm_Locale::lmsg('certvaliduntil'),
                'noEscape' => true,
            ),
            'column-7' => array(
                'title' => pm_Locale::lmsg('certstatus'),
                'noEscape' => true,
            ),
            'column-8' => array(
                'title' => pm_Locale::lmsg('certinstalled'),
                'noEscape' => true,
            ),
            'column-9' => array(
                'title' => pm_Locale::lmsg('actions'),
                'noEscape' => true,
            ),
        ));
        // Take into account listDataAction corresponds to the URL /list-data/
        $list->setDataUrl(array('action' => 'list-data'));

        return $list;
    }
    
    public function listDataAction()
    {
        $list = $this->getCertList($this->account->getCerts());
        
        // Json data from pm_View_List_Simple
        $this->_helper->json($list->fetchData());
    }  
}