<?php
/**
 * Partner API Library
 * 
 * @copyright Copyright (c) 2013-2014 Unizeto Technologies SA
 * @license license.txt
 */

//require_once 'type.php';
//require_once 'typeFiles.php';

/*
<xs:complexType name="document">
    <xs:sequence>
        <xs:choice>
            <xs:element name="id" type="xs:long"/>
            <xs:sequence>
                <xs:element name="description" type="xs:string"/>
                <xs:element name="type" type="tns:documentTypeEnum"/>
            </xs:sequence>
        </xs:choice>
        <xs:element name="files" type="tns:files"/>
    </xs:sequence>
</xs:complexType>
*/

/**
 * This class represents the "document" WSDL type.
 * 
 * It is based on the PartnerAPIType class and derives some properties and methods from that class.
 * Some of element are subject to choice. You can use either "id" or "description" and "type".
 * The "files" element is always required.
 * 
 * @method PartnerAPITypeDocument setId(long $value The id to be set) Sets the "id" element
 * @method long getId() Gets the "id" element
 * @property long $id Gets the "id" element
 * 
 * @method PartnerAPITypeDocument setDescription(string $value The description to be set) Sets the "description" element
 * @method string getDescription() Gets the "description" element
 * @property string $description Gets the "description" element
 * 
 * @method PartnerAPITypeDocument setType(string $value The type to be set) Sets the "type" element
 * @method string getType() Gets the "type" element
 * @property string $type Gets the "type" element
 * 
 * @method PartnerAPITypeDocument setFiles(PartnerAPITypeFiles $value The files to be set) Sets the "files" element
 * @method PartnerAPITypeFiles getFiles() Gets the "files" element
 * @property PartnerAPITypeFiles $files Gets the "files" element
 * 
 * @package types
 * @since 1.4.1
 */
class PartnerAPITypeDocument extends PartnerAPIType {
/*
    protected $choices = array(
        array(
            array('id'),
            array('description', 'type')
        )
    );
*/
    protected function initData() {
        return array(
            'id'          => array('min' => 1, 'max' => 1, 'value' => NULL, 'type' => 'long', 'nillable' => FALSE),
            'description' => array('min' => 1, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'type'        => array('min' => 1, 'max' => 1, 'value' => NULL, 'type' => 'string', 'nillable' => FALSE),
            'files'       => array('min' => 1, 'max' => 1, 'value' => new PartnerAPITypeFiles(), 'type' => 'PartnerAPITypeFiles', 'nillable' => FALSE)
        );
    }

}
