<?php
/*
 * * ******************************************************************
 *
 *   CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *   AUTHOR                         ->     dariusz.bi@modulesgarden.com
 *   CONTACT                        ->       contact@modulesgarden.com
 *
 *  This software is furnished under a license and may be used and copied
 *  only  in  accordance  with  the  terms  of such  license and with the
 *  inclusion of the above copyright notice.  This software  or any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and  ownership of the  software is  hereby
 *  transferred.
 *
 * * ******************************************************************
 */

class CertumSSLConfiguration
{
    private $values = array();

    function __construct()
    {
        $result = MGMySQL::query("
            SELECT 
                name
                ,value
            FROM
                certumssl_configuration
        ");

        while ($row = $result->fetch()) {
            $this->values[$row['name']] = $row['value'];
        }
    }

    public function __isset($name)
    {
        if (isset($this->values[$name])) {
            return true;
        }
        return false;
    }

    public function __get($name)
    {
        if (isset($this->values[$name])) {
            return $this->values[$name];
        }
        return null;
    }

    public function __set($name, $value)
    {
        $this->values[$name] = $value;

        $result = MGMySQL::query("
            SELECT
                name
                ,value
            FROM
                certumssl_configuration
            WHERE
                name = '".$name."'
        ");

        $row = $result->fetch();

        if ($row && $row != '' && !empty($row)) {
            MGMySQL::query("
                UPDATE
                    certumssl_configuration
                SET
                   value= '".$value."'
                WHERE
                    name = '".$name."'
            ");
        } else {
            MGMySQL::query("
            INSERT INTO 
                    certumssl_configuration 
                    (name, value)
            VALUES 
                    (:name, :value)
        ", array(
                ':name' => $name
                , ':value' => $value
            ));
        }
    }

    public function getAPIAccountsParams()
    {
        $apiAccountsParams = array();

        $result = MGMySQL::query("
            SELECT
                name
                ,value
                ,relid
            FROM
                certumssl_configuration
            WHERE
                relid > 0
            ORDER BY
                relid
            ASC
        ");

        while ($row = $result->fetch()) {

            if ($row['name'] == 'api_login') $apiAccountsParams[$row['relid']]['api_login'] = $row['value'];

            if ($row['name'] == 'api_password') $apiAccountsParams[$row['relid']]['api_password'] = $row['value'];

            if ($row['name'] == 'api_wsdl_url') $apiAccountsParams[$row['relid']]['api_wsdl_url'] = $row['value'];

            if ($row['name'] == 'api_wsdl_products') $apiAccountsParams[$row['relid']]['api_wsdl_products'] = $row['value'];

            if ($row['name'] == 'api_wsdl_lang') $apiAccountsParams[$row['relid']]['api_wsdl_lang'] = $row['value'];
        }

        return $apiAccountsParams;
    }

    public function apiAccountsParamsClean()
    {
        $result = MGMySQL::query("
            UPDATE
                certumssl_configuration
            SET
                value = ''
            WHERE
                name = 'api_wsdl_url'
            OR
                name = 'api_login'
            OR
                name = 'api_password'
            OR
                name = 'api_wsdl_products'
            OR
                name = 'api_wsdl_lang'
        ");
    }

    public function getProductsByRelId($relid)
    {
        $products = array();
        $result   = MGMySQL::query("
            SELECT
                value
            FROM
                certumssl_configuration
            WHERE
                name = 'api_wsdl_products'
            AND
                relid = '".$relid."'
        ");

        $row = $result->fetch();

        $products = json_decode($row['value'], true);
        return $products;
    }

    public function setAPIAccountsParams($name, $value, $relid)
    {

        $apiAccountsParams = array();
        $result            = MGMySQL::query("
            SELECT
                name
                ,value
                ,relid
            FROM
                certumssl_configuration
            WHERE
                name = '".$name."'
            AND
                relid = '".$relid."'
        ");

        $row = $result->fetch();

        if ($row && $row != '' && !empty($row)) {
            MGMySQL::query("
                UPDATE
                    certumssl_configuration
                SET
                   value= '".$value."'
                WHERE
                    name = '".$name."'
                AND
                    relid = '".$relid."'
            ");
        } else {

            MGMySQL::query("
            INSERT INTO
                    certumssl_configuration
                    (name, value, relid)
            VALUES
                    (:name, :value, :relid)
        ", array(
                ':name' => $name,
                ':value' => $value,
                ':relid' => $relid,
            ));
        }
    }

    public function getAPIAccountByRelId($relid)
    {
        $apiAccountParams = array('relid' => $relid);
        $result           = MGMySQL::query("
            SELECT
                name
                ,value
                ,relid
            FROM
                certumssl_configuration
            WHERE
                relid = '".$relid."'
        ");

        while ($row = $result->fetch()) {
            if ($row['name'] == 'api_login') $apiAccountParams['api_login'] = $row['value'];

            if ($row['name'] == 'api_password') $apiAccountParams['api_password'] = $row['value'];

            if ($row['name'] == 'api_wsdl_url') $apiAccountParams['api_url'] = $row['value'];

            if ($row['name'] == 'api_wsdl_lang') $apiAccountParams['api_wsdl_lang'] = $row['value'];
        }

        return $apiAccountParams;
    }

    public function getFirstAccountParams()
    {
        $apiAccountParams = array('relid' => 1);

        $result = MGMySQL::query("
            SELECT
                name
                ,value
                ,relid
            FROM
                certumssl_configuration
            WHERE
                relid = '1'
        ");

        while ($row = $result->fetch()) {
            if ($row['name'] == 'api_login') $apiAccountParams['api_login'] = $row['value'];

            if ($row['name'] == 'api_password') $apiAccountParams['api_password'] = $row['value'];

            if ($row['name'] == 'api_wsdl_url') $apiAccountParams['api_url'] = $row['value'];

            if ($row['name'] == 'api_wsdl_lang') $apiAccountParams['api_wsdl_lang'] = $row['value'];
        }

        return $apiAccountParams;
    }

    public function getAccountByPrductType($productType)
    {
        $apiAccountParams = array();
       
        $result = MGMySQL::query("
            SELECT
                name
                ,value
                ,relid
            FROM
                certumssl_configuration
            WHERE
                name = 'api_wsdl_products'
            ORDER BY
                relid
            ASC
        ");

        $relid = "";
        while ($row   = $result->fetch()) {
            $accountProductTypes = json_decode($row['value'], true);
            foreach ($accountProductTypes as $accountProductType) {
                if ($accountProductType == $productType) {
                    $relid = $row['relid'];
                    break 2;
                }
            }
        }

        if ($relid != "") {
            $apiAccountParams['relid'] = $relid;
            $result                    = MGMySQL::query("
                SELECT
                    name
                    ,value
                    ,relid
                FROM
                    certumssl_configuration
                WHERE
                    relid = '".$relid."'
            ");

            while ($row = $result->fetch()) {
                if ($row['name'] == 'api_login') $apiAccountParams['api_login'] = $row['value'];

                if ($row['name'] == 'api_password') $apiAccountParams['api_password'] = $row['value'];

                if ($row['name'] == 'api_wsdl_url') $apiAccountParams['api_url'] = $row['value'];

                if ($row['name'] == 'api_wsdl_lang') $apiAccountParams['api_wsdl_lang'] = $row['value'];
            }

            return $apiAccountParams;
        }
        return false;
    }

    public function getLanguageByProductCode($productType)
    {
        $apiAccountParams = array();

        $result = MGMySQL::query("
            SELECT
                name
                ,value
                ,relid
            FROM
                certumssl_configuration
            WHERE
                name = 'api_wsdl_products'
            ORDER BY
                relid
            ASC
        ");

        $relid = "";
        while ($row   = $result->fetch()) {
            $accountProductTypes = json_decode($row['value'], true);
            foreach ($accountProductTypes as $accountProductType) {
                if ($accountProductType == $productType) {
                    $relid = $row['relid'];
                    break 2;
                }
            }
        }



        if ($relid != "") {
            $result = MGMySQL::query("
                SELECT
                    name
                    ,value
                    ,relid
                FROM
                    certumssl_configuration
                WHERE
                    relid = '".$relid."'
            ");

            while ($row = $result->fetch()) {
                if ($row['name'] == 'api_wsdl_lang') $apiAccountParams['api_wsdl_lang'] = $row['value'];
            }
            return $apiAccountParams['api_wsdl_lang'];
        }
        return false;
    }
}