<?php

/*
 * * ******************************************************************
 *
 *   CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *   AUTHOR                         ->     dariusz.bi@modulesgarden.com
 *   CONTACT                        ->       contact@modulesgarden.com
 *
 *  This software is furnished under a license and may be used and copied
 *  only  in  accordance  with  the  terms  of such  license and with the
 *  inclusion of the above copyright notice.  This software  or any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and  ownership of the  software is  hereby
 *  transferred.
 *
 * * ******************************************************************
 */

class MGCronTask
{

    public $userId;
    public $orderId;
    public $domainId;
    public $createDate;
    public $activateDate;
    public $finished = 0;
    private $_tableName;

    function __construct(array $params = array())
    {
        $this->load($params);

        if (empty($this->createDate)) {
            $this->createDate = date('Y-m-d H:i:s');
        }
    }

    function load(array $params)
    {
        foreach ($params as $propertyName => $propertyValue) {
            if (property_exists($this, $propertyName)) {
                $this->{$propertyName} = $propertyValue;
            }
        }
    }

    function create()
    {
        $toSave = clone $this;

        MGMySQL::insert($this->_tableName, array(
            'user_id'               => $toSave->userId, 
            'order_id'              => $toSave->orderId, 
            'domain_id'             => $toSave->domainId, 
            'create_date'           => $toSave->createDate, 
            'activate_date'         => '0000-00-00 00:00:00', //$toSave->activateDate ////0000-00-00 00:00:00, 
            'last_try_date'         => $toSave->createDate, 
            'admin_failnotify_date' => '0000-00-00 00:00:00', //$toSave->activateDate ////0000-00-00 00:00:00, 
            'file_exist'            => 0, 
            'verify_domain_sended'  => 0,
            'finished'              => 0
        ));
    }

    function update()
    {
        $toSave = clone $this;

        MGMySQL::update($this->_tableName, array(
            'user_id'       => $toSave->userId, 
            'domain_id'     => $toSave->domainId, 
            'activate_date' => $toSave->activateDate, 
            'last_try_date' => date('Y-m-d H:i:s'), 
            'finished'      => $toSave->finished
                ), array(
            'order_id' => $toSave->orderId
        ));
    }
    
    function updateFileExist($exist = 0)
    {
        $toSave = clone $this;

        MGMySQL::update($this->_tableName, array(
            'file_exist' => (int)$exist
                ), array(
            'order_id' => $toSave->orderId
        ));
    }
    
    function updateDomainVerifySeded($sended = 0)
    {
        $toSave = clone $this;

        MGMySQL::update($this->_tableName, array(
            'verify_domain_sended' => (int)$sended
                ), array(
            'order_id' => $toSave->orderId
        ));
    }

    function updateAdminNotifyDate()
    {
        $toSave = clone $this;
        MGMySQL::update($this->_tableName, array('admin_failnotify_date' => date('Y-m-d H:i:s')), array('order_id' => $toSave->orderId));
        $this->updateLastTry();
    }

    function updateLastTry()
    {
        $toSave = clone $this;
        MGMySQL::update($this->_tableName, array('last_try_date' => date('Y-m-d H:i:s')), array('order_id' => $toSave->orderId));
    }

    function delete()
    {
        if (empty($this->orderVoucher)) {
            return false;
        }

        MGMySQL::delete($this->_tableName, array(
            'orderVoucher' => $this->orderVoucher
        ));
    }
    
    function fileExist()
    {
        $q = MGMySQL::query("
            SELECT 
                file_exist 
            FROM 
                " . $this->_tableName . "
            WHERE 
                `order_id` = '" . $this->orderId . "'    
        ")->fetch();
        
        if($q['file_exist'] == 0){
            return false;
        }
        
        return true;
    }

    function setFinished()
    {
        $this->finished = 1;
        $this->update();
    }

    function getAllTasks()
    {
        $q = MGMySQL::query("
            SELECT 
                * 
            FROM 
                " . $this->_tableName
                )->fetchAll();

        return $q;
    }

    function getTaskByOrderId()
    {
        $q = MGMySQL::query("
            SELECT 
                *
            FROM 
                `" . $this->_tableName . "` 
            WHERE 
                `order_id` = '" . $this->orderId . "'
        ")->fetchAll();

        return $q;
    }

    function passDaysFromLastNotify($days)
    {
        $q = MGMySQL::query("
            SELECT 
                *
            FROM 
                `" . $this->_tableName . "` 
            WHERE 
                `admin_failnotify_date` <= DATE_ADD(CURDATE(), INTERVAL -" . (int) $days . " DAY)
            OR
                `admin_failnotify_date` = '0000-00-00 00:00:00'
            AND 
            `order_id` = '" . $this->order_id . "'
        ")->fetch();

        return $q;
    }

    function domainVerifySeded($voucherCode)
    {
        $q = MGMySQL::query("
            SELECT 
                verify_domain_sended 
            FROM 
                " . $this->_tableName . "
            WHERE 
                `orderVoucher` = '" . $voucherCode . "'    
        ")->fetch();
        
        if($q['verify_domain_sended'] == 0){
            return false;
        }
        
        if($q['verify_domain_sended'] == 1){
            return true;
        }
    }

}
