<?php
/* 
 * * ******************************************************************
 *
 *   CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *   AUTHOR                         ->     dariusz.bi@modulesgarden.com
 *   CONTACT                        ->       contact@modulesgarden.com
 *
 *  This software is furnished under a license and may be used and copied
 *  only  in  accordance  with  the  terms  of such  license and with the
 *  inclusion of the above copyright notice.  This software  or any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and  ownership of the  software is  hereby
 *  transferred.
 *
 * * ******************************************************************
 */

class PleskLocalAPIDriver extends AbstractLocalAPIDriver
{
    protected $apiKey;
    private $sortCol        = 'domain';
    private $sortVect       = 'ASC';
    public $currentUsername = false;
    public $currentDomain   = false;
    public $lastParams      = array();
    public $typeList        = array('base','addon','parked');
        
    function __construct($params) 
    {
        parent::__construct($params);
    }

    public function _connect($params)
    {
            
    }
    
    function installCrt($domain, $csr, $key, $crt, $crt_ca = null){
        $request = '<certificate>
                        <install>
                            <name>'.$domain.'</name>
                            <webspace>'.$domain.'</webspace>
                            <content>
                                <csr>'.$csr.'</csr>
                                <pvt>'.$key.'</pvt>
                                <cert>'.$crt.'</cert>';
        if($crt_ca != null){
            $request         .= '<ca>'.$crt_ca.'</ca>';
        }
        $request            .= '</content>
                        </install>
                    </certificate>';

        $installResponse = pm_ApiRpc::getService()->call($request, 'admin')->certificate->install->result;

        $installStatus = (array) $installResponse->status;
        if($installStatus[0] == 'ok'){
            return true;
        }
        $error = (array)$installResponse->errtext;
        return $error[0];
    }
    
    
       //Generate CSR 
    function generateCsr($params = null)
    {
        $request = 
        '<certificate>
            <generate>
               <info>
                  <bits>2048</bits>
                  <country>'.$params['country'].'</country>
                  <state>'.$params['state'].'</state>
                  <location>'.$params['city'].'</location>
                  <company>'.$params['OrganizationName'].'</company>
                  <email>'.$params['email'].'</email>
                  <name>'.$params['domain'].'</name>
               </info>
            </generate>
        </certificate>';
        
        $csrResponse = pm_ApiRpc::getService()->call($request, 'admin')->certificate->generate->result;

        $csrStatus = (array) $csrResponse->status;

        if($csrStatus[0] == 'ok'){
            $csr = (array) $csrResponse->csr;
            $pvt = (array) $csrResponse->pvt;

            return array(
                'csr' => $csr[0],
                'key' => $pvt[0],
                'crt' => null
            );
        }
        
    }

    public function getAccounts()
    {
    }
    
    function getUserDomains($user = null, $main = null, $userid = null )
    {
        
        $domainsList = array();
        
        $q = MGMySQL::query("
            SELECT 
                d.id        as domainid,
                d.name      as domain,
                u.id        as userid,
                u.login     as username
            FROM
                domains d
            LEFT JOIN
                clients u 
            ON 
                d.cl_id = u.id
            WHERE 
                u.id = ".(int)$userid."
            ORDER BY
                d.name ASC  
        ")->fetchAll();
        
        foreach($q as $r)
        {
            $domainsList[] = array(
                'domain'      => $r['domain']
                ,'domainid'   => $r['domainid']
                ,'userid'     => $r['userid']
            );  
        }
        
        return $domainsList;
    }
    
    function getUserDomainById($domainId)
    {
        
        $q = MGMySQL::query("
            SELECT 
                *
            FROM
                domains
            WHERE 
                id = '".$domainId."'
            ORDER BY
                name ASC 
            LIMIT 1
        ")->fetch();

        return $q;
    }
    
    function getDomainRootPath($domainId)
    {
        $q = MGMySQL::query("
            SELECT 
                www_root
            FROM
                hosting
            WHERE 
                dom_id = '".$domainId."'
            ORDER BY
                dom_id ASC 
            LIMIT 1
        ")->fetch();

        return $q['www_root'];
    }
    
    function clearConfiguration()
    {
        MGMySQL::query("
            DELETE
            FROM 
                certumssl_configuration
            WHERE 
                name <> 'apilogs_turnon_value'
            AND 
               name <>  'email'
            AND 
               name <>  'sender'
            AND 
               name <>  'success_email_subject'
            AND 
               name <>  'success_email_message'
            AND 
               name <>  'failure_email_subject'
            AND 
               name <>  'failure_email_message'
        ");
    }

    function getUserEmailById($userID){
        
        $q = MGMySQL::query("
            SELECT 
                email
            FROM
                clients
            WHERE 
                id = ".(int)$userID."
            ORDER BY
                email ASC  
            LIMIT 1
        ")->fetch();
        
        return $q['email'];
    }
    
    function getUserNameById($userID){
        
        $q = MGMySQL::query("
            SELECT 
                pname
            FROM
                clients
            WHERE 
                id = ".(int)$userID."
            ORDER BY
                pname ASC  
            LIMIT 1
        ")->fetch();
        return $q['pname'];
    }
    
    function getDomainCertyficate($domain)
    {
        //Powinno zwrucic text certyfiaktu narazie zwraca nazwe ? 
        $request =
        '<certificate>
            <get-pool>
               <filter>
                  <domain-name>'.$domain.'</domain-name>
               </filter>
            </get-pool>
        </certificate>';
        echo '<pre>';

        $domainCertyficatesResponse = pm_ApiRpc::getService()->call($request, 'admin')->certificate->{'get-pool'}->result;

        $domainCertyficatesResponseStatus = (array) $csrResponse->status;

        if($domainCertyficatesResponseStatus[0] == 'ok'){
            return $domainCertyficatesResponse->certificates;
        }


        return false;
    }
    
}
