<?php

/* 
 * * ******************************************************************
 *
 *   CREATED BY MODULESGARDEN       ->        http://modulesgarden.com
 *   AUTHOR                         ->     dariusz.bi@modulesgarden.com
 *   CONTACT                        ->       contact@modulesgarden.com
 *
 *  This software is furnished under a license and may be used and copied
 *  only  in  accordance  with  the  terms  of such  license and with the
 *  inclusion of the above copyright notice.  This software  or any other
 *  copies thereof may not be provided or otherwise made available to any
 *  other person.  No title to and  ownership of the  software is  hereby
 *  transferred.
 *
 * * ******************************************************************
 */

pm_Loader::registerAutoload();
pm_Context::init('CertumSSL');
pm_Bootstrap::init();

$db = pm_Bootstrap::getDbAdapter();
$db->query("
    CREATE TABLE IF NOT EXISTS `certumssl_configuration` (
      `id` int(11) NOT NULL AUTO_INCREMENT,
      `name` varchar(40) NOT NULL,
      `value` text,
      `relid` int(11) NOT NULL DEFAULT '0',
      PRIMARY KEY (`id`)
    ) ENGINE=MyISAM DEFAULT CHARSET=latin1;
");

$db->query("
    CREATE TABLE IF NOT EXISTS `certumssl_cron_tasks` (
      `id` int(11) NOT NULL AUTO_INCREMENT,
      `rel_id` int(11) NOT NULL,
      `user_id` varchar(40) DEFAULT NULL,
      `order_id` varchar(255) NOT NULL,
      `domain_id` varchar(40) DEFAULT NULL,
      `create_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
      `activate_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
      `last_try_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
      `admin_failnotify_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
      `file_exist` int(1) NOT NULL DEFAULT '0',
      `verify_domain_sended` int(11) NOT NULL DEFAULT '0',
      `finished` tinyint(1) NOT NULL DEFAULT '0',
      PRIMARY KEY (`id`)
    ) ENGINE=MyISAM DEFAULT CHARSET=latin1;
");

$db->query("
    CREATE TABLE IF NOT EXISTS `certumssl_api_logs` (
      `id` int NOT NULL AUTO_INCREMENT,
      `date` datetime NOT NULL,
      `request` text,
      `response` text,
      PRIMARY KEY (`id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=latin1; 
");

$db->query("
    CREATE TABLE IF NOT EXISTS `certumssl_reissued_orders` (
      `id` int(11) NOT NULL AUTO_INCREMENT,
      `order_id` varchar(255) NOT NULL,
      `parent_id` varchar(255) NOT NULL,
      `Finished` int(10) DEFAULT '0',
      `date` datetime NOT NULL,
      PRIMARY KEY (`id`)
    ) ENGINE=MyISAM DEFAULT CHARSET=latin1;
");

$db->query("
    CREATE TABLE IF NOT EXISTS `certumssl_orders` (
      `id` int(11) NOT NULL AUTO_INCREMENT,
      `rel_id`  int(11) NOT NULL,
      `order_id` varchar(255) NOT NULL,
      `user_id` varchar(120) NOT NULL,
      `domain_id` varchar(120) NOT NULL,
      `used_voucher` varchar(60) NOT NULL,
      `used_csr` text NOT NULL,
      `csr_key` text NOT NULL,
      `crt` text,
      `file_name` text,
      `file_content` text,
      `status` varchar(20) NOT NULL,
      `file_created` int(10) DEFAULT '0',
      `Finished` int(10) DEFAULT '0',
      `voucher_create_date` datetime NOT NULL,
      `voucher_activate_date` datetime NOT NULL,
      `date` datetime NOT NULL,
      PRIMARY KEY (`id`)
    ) ENGINE=MyISAM DEFAULT CHARSET=latin1;
");
/*
$db->query("
    INSERT IGNORE
    INTO 
    certumssl_configuration (`name`,`value`, `relid`)
    VALUES 
    ('email','test@admin.com',0),
    ('sender','noreply@example.com',0),
    ('success_email_subject','Successfull Certificate instalation',0),
    ('success_email_message','On Domain:\{\$domain\},\nOrderID: \{\$certificate_id\},\nUsed Voucher Code: \{\$voucher_code\}',0),
    ('failure_email_subject','Failed Certificate instalation',0),
    ('failure_email_message','On Domain:\{\$domain\},\norderID: \{\$certificate_id\},\nUsed Voucher Code: \{\$voucher_code\}',0),
    ('apilogs_turnon_value','off',0),
    ('logs_limit',1000,0)
");
 */